/* This file is automatically generated by Lemon from input grammar
** source file "parser.y". */
/*
** 2000-05-29
**
** The author disclaims copyright to this source code.  In place of
** a legal notice, here is a blessing:
**
**    May you do good and not evil.
**    May you find forgiveness for yourself and forgive others.
**    May you share freely, never taking more than you give.
**
*************************************************************************
** Driver template for the LEMON parser generator.
**
** The "lemon" program processes an LALR(1) input grammar file, then uses
** this template to construct a parser.  The "lemon" program inserts text
** at each "%%" line.  Also, any "P-a-r-s-e" identifer prefix (without the
** interstitial "-" characters) contained in this template is changed into
** the value of the %name directive from the grammar.  Otherwise, the content
** of this template is copied straight through into the generate parser
** source file.
**
** The following is the concatenation of all %include directives from the
** input grammar file:
*/
/************ Begin %include sections from the grammar ************************/
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <assert.h>

#include "../parse.h"

// unescape a string (non null terminated) and return the new length (may be shorter than the original. This manipulates the string itself
static size_t unescapen(char *s, size_t sz) {

  char *dst = s;
  char *src = dst;
  char *end = s + sz;
  while (src < end) {
      // unescape
      if (*src == '\\' && src + 1 < end &&
         (ispunct(*(src+1)) || isspace(*(src+1)))) {
          ++src;
          continue;
      }
      *dst++ = *src++;
  }

  return (size_t)(dst - s);
}

#define NODENN_BOTH_VALID 0
#define NODENN_BOTH_INVALID -1
#define NODENN_ONE_NULL 1
// Returns:
// 0 if a && b
// -1 if !a && !b
// 1 if a ^ b (i.e. !(a&&b||!a||!b)). The result is stored in `out`
static int one_not_null(void *a, void *b, void *out) {
    if (a && b) {
        return NODENN_BOTH_VALID;
    } else if (a == NULL && b == NULL) {
        return NODENN_BOTH_INVALID;
    } if (a) {
        *(void **)out = a;
        return NODENN_ONE_NULL;
    } else {
        *(void **)out = b;
        return NODENN_ONE_NULL;
    }
}

static void setup_trace(QueryParseCtx *ctx) {
#ifdef PARSER_DEBUG
  void RSQueryParser_Trace(FILE*, char*);
  ctx->trace_log = fopen("/tmp/lemon_query.log", "w");
  RSQueryParser_Trace(ctx->trace_log, "tr: ");
#endif
}

static void reportSyntaxError(QueryError *status, QueryToken* tok, const char *msg) {
  if (tok->type == QT_TERM || tok->type == QT_TERM_CASE) {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX,
      "%s at offset %d near %.*s", msg, tok->pos, tok->len, tok->s);
  } else if (tok->type == QT_NUMERIC) {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX,
      "%s at offset %d near %f", msg, tok->pos, tok->numval);
  } else {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX, "%s at offset %d", msg, tok->pos);
  }
}

/**************** End of %include directives **********************************/
/* These constants specify the various numeric values for terminal symbols.
***************** Begin token definitions *************************************/
#ifndef LOWEST
#define LOWEST                          1
#define TEXTEXPR                        2
#define ORX                             3
#define OR                              4
#define MODIFIER                        5
#define RP                              6
#define RB                              7
#define RSQB                            8
#define TERM                            9
#define QUOTE                          10
#define LP                             11
#define LB                             12
#define LSQB                           13
#define TILDE                          14
#define MINUS                          15
#define AND                            16
#define ARROW                          17
#define COLON                          18
#define NUMBER                         19
#define SIZE                           20
#define STAR                           21
#define TAGLIST                        22
#define TERMLIST                       23
#define PREFIX                         24
#define SUFFIX                         25
#define CONTAINS                       26
#define PERCENT                        27
#define ATTRIBUTE                      28
#define VERBATIM                       29
#define WILDCARD                       30
#define AS_T                           31
#define SEMICOLON                      32
#endif
/**************** End token definitions ***************************************/

/* The next sections is a series of control #defines.
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used to store the integer codes
**                       that represent terminal and non-terminal symbols.
**                       "unsigned char" is used if there are fewer than
**                       256 symbols.  Larger types otherwise.
**    YYNOCODE           is a number of type YYCODETYPE that is not used for
**                       any terminal or nonterminal symbol.
**    YYFALLBACK         If defined, this indicates that one or more tokens
**                       (also known as: "terminal symbols") have fall-back
**                       values which should be used if the original symbol
**                       would not parse.  This permits keywords to sometimes
**                       be used as identifiers, for example.
**    YYACTIONTYPE       is the data type used for "action codes" - numbers
**                       that indicate what to do in response to the next
**                       token.
**    RSQueryParser_v2_TOKENTYPE     is the data type used for minor type for terminal
**                       symbols.  Background: A "minor type" is a semantic
**                       value associated with a terminal or non-terminal
**                       symbols.  For example, for an "ID" terminal symbol,
**                       the minor type might be the name of the identifier.
**                       Each non-terminal can have a different minor type.
**                       Terminal symbols all have the same minor type, though.
**                       This macros defines the minor type for terminal 
**                       symbols.
**    YYMINORTYPE        is the data type used for all minor types.
**                       This is typically a union of many types, one of
**                       which is RSQueryParser_v2_TOKENTYPE.  The entry in the union
**                       for terminal symbols is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.  If
**                       zero the stack is dynamically sized using realloc()
**    RSQueryParser_v2_ARG_SDECL     A static variable declaration for the %extra_argument
**    RSQueryParser_v2_ARG_PDECL     A parameter declaration for the %extra_argument
**    RSQueryParser_v2_ARG_PARAM     Code to pass %extra_argument as a subroutine parameter
**    RSQueryParser_v2_ARG_STORE     Code to store %extra_argument into yypParser
**    RSQueryParser_v2_ARG_FETCH     Code to extract %extra_argument from yypParser
**    RSQueryParser_v2_CTX_*         As RSQueryParser_v2_ARG_ except for %extra_context
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYNTOKEN           Number of terminal symbols
**    YY_MAX_SHIFT       Maximum value for shift actions
**    YY_MIN_SHIFTREDUCE Minimum value for shift-reduce actions
**    YY_MAX_SHIFTREDUCE Maximum value for shift-reduce actions
**    YY_ERROR_ACTION    The yy_action[] code for syntax error
**    YY_ACCEPT_ACTION   The yy_action[] code for accept
**    YY_NO_ACTION       The yy_action[] code for no-op
**    YY_MIN_REDUCE      Minimum value for reduce actions
**    YY_MAX_REDUCE      Maximum value for reduce actions
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/************* Begin control #defines *****************************************/
#define YYCODETYPE unsigned char
#define YYNOCODE 64
#define YYACTIONTYPE unsigned short int
#define RSQueryParser_v2_TOKENTYPE QueryToken
typedef union {
  int yyinit;
  RSQueryParser_v2_TOKENTYPE yy0;
  QueryAttribute yy7;
  VectorQueryParams yy10;
  SingleVectorQueryParam yy29;
  QueryParam * yy30;
  QueryAttribute * yy33;
  QueryNode * yy51;
  Vector* yy114;
  RangeNumber yy127;
} YYMINORTYPE;
#ifndef YYSTACKDEPTH
#define YYSTACKDEPTH 256
#endif
#define RSQueryParser_v2_ARG_SDECL  QueryParseCtx *ctx ;
#define RSQueryParser_v2_ARG_PDECL , QueryParseCtx *ctx 
#define RSQueryParser_v2_ARG_PARAM ,ctx 
#define RSQueryParser_v2_ARG_FETCH  QueryParseCtx *ctx =yypParser->ctx ;
#define RSQueryParser_v2_ARG_STORE yypParser->ctx =ctx ;
#define RSQueryParser_v2_CTX_SDECL
#define RSQueryParser_v2_CTX_PDECL
#define RSQueryParser_v2_CTX_PARAM
#define RSQueryParser_v2_CTX_FETCH
#define RSQueryParser_v2_CTX_STORE
#define YYFALLBACK 1
#define YYNSTATE             121
#define YYNRULE              96
#define YYNRULE_WITH_ACTION  93
#define YYNTOKEN             33
#define YY_MAX_SHIFT         120
#define YY_MIN_SHIFTREDUCE   181
#define YY_MAX_SHIFTREDUCE   276
#define YY_ERROR_ACTION      277
#define YY_ACCEPT_ACTION     278
#define YY_NO_ACTION         279
#define YY_MIN_REDUCE        280
#define YY_MAX_REDUCE        375
/************* End control #defines *******************************************/
#define YY_NLOOKAHEAD ((int)(sizeof(yy_lookahead)/sizeof(yy_lookahead[0])))

/* Define the yytestcase() macro to be a no-op if is not already defined
** otherwise.
**
** Applications can choose to define yytestcase() in the %include section
** to a macro that can assist in verifying code coverage.  For production
** code the yytestcase() macro should be turned off.  But it is useful
** for testing.
*/
#ifndef yytestcase
# define yytestcase(X)
#endif


/* Next are the tables used to determine what action to take based on the
** current state and lookahead token.  These tables are used to implement
** functions that take a state number and lookahead value and return an
** action integer.  
**
** Suppose the action integer is N.  Then the action is determined as
** follows
**
**   0 <= N <= YY_MAX_SHIFT             Shift N.  That is, push the lookahead
**                                      token onto the stack and goto state N.
**
**   N between YY_MIN_SHIFTREDUCE       Shift to an arbitrary state then
**     and YY_MAX_SHIFTREDUCE           reduce by rule N-YY_MIN_SHIFTREDUCE.
**
**   N == YY_ERROR_ACTION               A syntax error has occurred.
**
**   N == YY_ACCEPT_ACTION              The parser accepts its input.
**
**   N == YY_NO_ACTION                  No such action.  Denotes unused
**                                      slots in the yy_action[] table.
**
**   N between YY_MIN_REDUCE            Reduce by rule N-YY_MIN_REDUCE
**     and YY_MAX_REDUCE
**
** The action table is constructed as a single large table named yy_action[].
** Given state S and lookahead X, the action is computed as either:
**
**    (A)   N = yy_action[ yy_shift_ofst[S] + X ]
**    (B)   N = yy_default[S]
**
** The (A) formula is preferred.  The B formula is used instead if
** yy_lookahead[yy_shift_ofst[S]+X] is not equal to X.
**
** The formulas above are for computing the action when the lookahead is
** a terminal symbol.  If the lookahead is a non-terminal (as occurs after
** a reduce action) then the yy_reduce_ofst[] array is used in place of
** the yy_shift_ofst[] array.
**
** The following are the tables generated in this section:
**
**  yy_action[]        A single table containing all actions.
**  yy_lookahead[]     A table containing the lookahead for each entry in
**                     yy_action.  Used to detect hash collisions.
**  yy_shift_ofst[]    For each state, the offset into yy_action for
**                     shifting terminals.
**  yy_reduce_ofst[]   For each state, the offset into yy_action for
**                     shifting non-terminals after a reduce.
**  yy_default[]       Default action for each state.
**
*********** Begin parsing tables **********************************************/
#define YY_ACTTAB_COUNT (798)
static const YYACTIONTYPE yy_action[] = {
 /*     0 */   371,  356,   46,   52,   12,  227,  199,   55,  361,  264,
 /*    10 */    45,   15,  346,   54,   13,   14,   76,  105,   93,  265,
 /*    20 */   266,   61,  116,  355,  220,  221,  222,   51,  268,  264,
 /*    30 */   223,   16,  227,  200,  345,   54,  264,   45,   15,  265,
 /*    40 */   266,   13,   14,   78,  118,  362,  265,  266,  115,   97,
 /*    50 */    53,  220,  221,  222,   51,  268,  280,  223,  264,   77,
 /*    60 */    12,  227,  113,  366,  117,  264,   45,   15,  265,  266,
 /*    70 */    13,   14,  276,   87,   78,  265,  266,  268,   95,   43,
 /*    80 */   220,  221,  222,   51,  268,  281,  223,  114,  366,   73,
 /*    90 */   227,  264,  328,   72,  264,   45,    1,  261,  260,   13,
 /*   100 */    14,  265,  266,  107,  265,  266,  274,  371,  102,  220,
 /*   110 */   221,  222,   51,  268,   49,  223,   16,  227,  343,  314,
 /*   120 */   366,  264,   45,   15,  354,  366,   13,   14,  327,   81,
 /*   130 */   206,  265,  266,   78,  371,   94,  220,  221,  222,   51,
 /*   140 */   268,  106,  223,   12,  227,  371,  349,  366,  264,   45,
 /*   150 */    15,  344,   47,   13,   14,   78,  105,  227,  265,  266,
 /*   160 */   108,  366,  101,  220,  221,  222,   51,  268,   98,  223,
 /*   170 */    16,  227,  313,  366,  269,  264,   45,   15,  111,  366,
 /*   180 */    13,   14,  270,  118,  207,  265,  266,  282,  300,  366,
 /*   190 */   220,  221,  222,   51,  268,   34,  223,  200,  301,   79,
 /*   200 */   264,   45,   33,  342,  100,   31,   32,  302,  118,   78,
 /*   210 */   265,  266,  301,   82,  351,  220,  221,  222,   51,  268,
 /*   220 */   103,  223,  227,   99,   43,   63,  264,   45,    1,  301,
 /*   230 */    85,   13,   14,  104,   43,   74,  265,  266,  274,   70,
 /*   240 */    64,  220,  221,  222,   51,  268,   80,  223,  227,   30,
 /*   250 */   301,   88,  264,   45,   15,  275,   42,   13,   14,  230,
 /*   260 */   105,  352,  265,  266,  301,   92,   65,  220,  221,  222,
 /*   270 */    51,  268,   83,  223,  227,   69,   68,   67,  264,   45,
 /*   280 */    15,  264,  208,   13,   14,  254,  118,   75,  265,  266,
 /*   290 */    66,  265,  266,  220,  221,  222,   51,  268,  350,  223,
 /*   300 */   268,   26,   69,  264,   45,   33,   40,   44,   31,   32,
 /*   310 */    86,  258,  259,  265,  266,  242,  226,   35,  220,  221,
 /*   320 */   222,   51,  268,   34,  223,  210,  109,  110,  264,   45,
 /*   330 */    33,  225,  112,   31,   32,  224,  118,  209,  265,  266,
 /*   340 */    62,   70,   17,  220,  221,  222,   51,  268,  279,  223,
 /*   350 */   227,  279,  279,  279,  264,   45,   15,  279,  279,   13,
 /*   360 */    14,  279,  279,  279,  265,  266,  279,  279,  279,  220,
 /*   370 */   221,  222,   51,  268,  279,  223,  279,  279,  279,  264,
 /*   380 */    45,   33,  279,  279,   31,   32,  279,  118,  279,  265,
 /*   390 */   266,  279,  279,  279,  220,  221,  222,   51,  268,   71,
 /*   400 */   223,  279,  279,   72,  264,   45,   33,  261,  260,   31,
 /*   410 */    32,  279,  279,  279,  265,  266,  271,  279,  264,  220,
 /*   420 */   221,  222,   51,  268,    4,  223,  279,  311,  265,  266,
 /*   430 */   312,  279,  120,  119,    5,  311,   60,  268,  312,  279,
 /*   440 */   279,  119,   38,   89,  279,  279,  278,   84,   91,  310,
 /*   450 */   366,  331,  279,    2,  332,   58,  311,  310,  366,  312,
 /*   460 */    90,  120,  119,    3,  279,  279,  279,  279,  279,  279,
 /*   470 */   279,  279,   89,   59,  366,  279,   96,   91,  310,  366,
 /*   480 */    22,  279,  279,  311,  279,  279,  312,  279,  120,  119,
 /*   490 */    25,  279,  335,  279,  279,  336,   56,  279,  279,   89,
 /*   500 */   279,  279,  279,  279,   91,  310,  366,  279,  279,  279,
 /*   510 */    23,  279,  279,  311,   57,  366,  312,  279,  120,  119,
 /*   520 */    24,  279,    9,  279,  279,  311,  279,  279,  312,   89,
 /*   530 */   120,  119,   10,  279,   91,  310,  366,  279,  279,  279,
 /*   540 */   279,   89,  279,  279,  279,  279,   91,  310,  366,  279,
 /*   550 */    19,  279,  279,  311,  279,  279,  312,  279,  120,  119,
 /*   560 */    20,  279,   18,  279,  279,  311,  279,  279,  312,   89,
 /*   570 */   120,  119,   21,  279,   91,  310,  366,  279,  279,  279,
 /*   580 */   279,   89,  279,  279,  279,  279,   91,  310,  366,  279,
 /*   590 */     2,  279,  279,  311,  279,  279,  312,  279,  120,  119,
 /*   600 */     3,  279,    8,  279,  279,  311,  279,  279,  312,   89,
 /*   610 */   120,  119,   11,  279,   91,  310,  366,  279,  279,  279,
 /*   620 */   279,   89,  279,  279,  279,  279,   91,  310,  366,  279,
 /*   630 */     6,  264,  279,  311,  279,  279,  312,  279,  120,  119,
 /*   640 */     7,  265,  266,  279,  279,  279,  220,  221,  222,   89,
 /*   650 */   268,  279,  223,  279,   91,  310,  366,  105,  279,  265,
 /*   660 */   266,  279,  279,  279,  220,  221,  222,   51,  268,  279,
 /*   670 */   223,  279,  118,  279,  265,  266,  279,  279,  279,  220,
 /*   680 */   221,  222,   51,  268,  311,  223,  311,  312,  279,  312,
 /*   690 */   119,   39,  119,   41,  265,  266,  340,  279,  279,  220,
 /*   700 */   221,  222,   51,  268,  338,  223,  310,  366,  310,  366,
 /*   710 */   279,  279,  311,  279,  279,  312,  279,  311,  119,   36,
 /*   720 */   312,  279,  311,  119,   37,  312,  279,  279,  119,   27,
 /*   730 */   311,  279,  279,  312,  310,  366,  119,   29,  279,  310,
 /*   740 */   366,  279,  279,  311,  310,  366,  312,  279,  279,  119,
 /*   750 */    28,  279,  310,  366,  279,  279,  279,  279,  279,  279,
 /*   760 */   279,  279,   48,  279,   71,  310,  366,  279,   72,  279,
 /*   770 */   279,  240,  261,  260,   71,  264,  279,  279,   72,  279,
 /*   780 */    73,  271,  261,  260,   72,  265,  266,  279,  261,  260,
 /*   790 */   279,  271,  279,   50,  268,  279,  279,  273,
};
static const YYCODETYPE yy_lookahead[] = {
 /*     0 */    53,   50,   51,   40,    4,    5,    6,   60,   53,    9,
 /*    10 */    10,   11,   61,   62,   14,   15,    9,   17,    7,   19,
 /*    20 */    20,   58,   59,   50,   24,   25,   26,   27,   28,    9,
 /*    30 */    30,    4,    5,    6,   61,   62,    9,   10,   11,   19,
 /*    40 */    20,   14,   15,   32,   17,   53,   19,   20,   28,    7,
 /*    50 */     9,   24,   25,   26,   27,   28,    0,   30,    9,   63,
 /*    60 */     4,    5,   58,   59,   28,    9,   10,   11,   19,   20,
 /*    70 */    14,   15,   31,   17,   32,   19,   20,   28,   47,   48,
 /*    80 */    24,   25,   26,   27,   28,    0,   30,   58,   59,   11,
 /*    90 */     5,    9,   59,   15,    9,   10,   11,   19,   20,   14,
 /*   100 */    15,   19,   20,   49,   19,   20,   21,   53,    7,   24,
 /*   110 */    25,   26,   27,   28,   60,   30,    4,    5,    0,   58,
 /*   120 */    59,    9,   10,   11,   58,   59,   14,   15,   59,   17,
 /*   130 */     7,   19,   20,   32,   53,   17,   24,   25,   26,   27,
 /*   140 */    28,   60,   30,    4,    5,   53,   58,   59,    9,   10,
 /*   150 */    11,    0,   60,   14,   15,   32,   17,    5,   19,   20,
 /*   160 */    58,   59,   57,   24,   25,   26,   27,   28,   17,   30,
 /*   170 */     4,    5,   58,   59,   20,    9,   10,   11,   58,   59,
 /*   180 */    14,   15,   28,   17,    7,   19,   20,    0,   58,   59,
 /*   190 */    24,   25,   26,   27,   28,    4,   30,    6,   34,   35,
 /*   200 */     9,   10,   11,    0,   17,   14,   15,   34,   17,   32,
 /*   210 */    19,   20,   34,   35,    0,   24,   25,   26,   27,   28,
 /*   220 */    17,   30,    5,   47,   48,   12,    9,   10,   11,   34,
 /*   230 */    35,   14,   15,   47,   48,    4,   19,   20,   21,   12,
 /*   240 */    13,   24,   25,   26,   27,   28,    8,   30,    5,   18,
 /*   250 */    34,   35,    9,   10,   11,    6,    4,   14,   15,    7,
 /*   260 */    17,    0,   19,   20,   34,   35,   12,   24,   25,   26,
 /*   270 */    27,   28,    8,   30,    5,   12,   13,   12,    9,   10,
 /*   280 */    11,    9,   10,   14,   15,   28,   17,    4,   19,   20,
 /*   290 */    13,   19,   20,   24,   25,   26,   27,   28,    0,   30,
 /*   300 */    28,   18,   12,    9,   10,   11,   12,   13,   14,   15,
 /*   310 */     8,    8,   28,   19,   20,    8,   27,    4,   24,   25,
 /*   320 */    26,   27,   28,    4,   30,   10,   27,   27,    9,   10,
 /*   330 */    11,   27,   27,   14,   15,   27,   17,   10,   19,   20,
 /*   340 */    18,   12,    4,   24,   25,   26,   27,   28,   64,   30,
 /*   350 */     5,   64,   64,   64,    9,   10,   11,   64,   64,   14,
 /*   360 */    15,   64,   64,   64,   19,   20,   64,   64,   64,   24,
 /*   370 */    25,   26,   27,   28,   64,   30,   64,   64,   64,    9,
 /*   380 */    10,   11,   64,   64,   14,   15,   64,   17,   64,   19,
 /*   390 */    20,   64,   64,   64,   24,   25,   26,   27,   28,   11,
 /*   400 */    30,   64,   64,   15,    9,   10,   11,   19,   20,   14,
 /*   410 */    15,   64,   64,   64,   19,   20,   28,   64,    9,   24,
 /*   420 */    25,   26,   27,   28,   33,   30,   64,   36,   19,   20,
 /*   430 */    39,   64,   41,   42,   43,   36,   27,   28,   39,   64,
 /*   440 */    64,   42,   43,   52,   64,   64,   55,   56,   57,   58,
 /*   450 */    59,   36,   64,   33,   39,   40,   36,   58,   59,   39,
 /*   460 */    45,   41,   42,   43,   64,   64,   64,   64,   64,   64,
 /*   470 */    64,   64,   52,   58,   59,   64,   56,   57,   58,   59,
 /*   480 */    33,   64,   64,   36,   64,   64,   39,   64,   41,   42,
 /*   490 */    43,   64,   36,   64,   64,   39,   40,   64,   64,   52,
 /*   500 */    64,   64,   64,   64,   57,   58,   59,   64,   64,   64,
 /*   510 */    33,   64,   64,   36,   58,   59,   39,   64,   41,   42,
 /*   520 */    43,   64,   33,   64,   64,   36,   64,   64,   39,   52,
 /*   530 */    41,   42,   43,   64,   57,   58,   59,   64,   64,   64,
 /*   540 */    64,   52,   64,   64,   64,   64,   57,   58,   59,   64,
 /*   550 */    33,   64,   64,   36,   64,   64,   39,   64,   41,   42,
 /*   560 */    43,   64,   33,   64,   64,   36,   64,   64,   39,   52,
 /*   570 */    41,   42,   43,   64,   57,   58,   59,   64,   64,   64,
 /*   580 */    64,   52,   64,   64,   64,   64,   57,   58,   59,   64,
 /*   590 */    33,   64,   64,   36,   64,   64,   39,   64,   41,   42,
 /*   600 */    43,   64,   33,   64,   64,   36,   64,   64,   39,   52,
 /*   610 */    41,   42,   43,   64,   57,   58,   59,   64,   64,   64,
 /*   620 */    64,   52,   64,   64,   64,   64,   57,   58,   59,   64,
 /*   630 */    33,    9,   64,   36,   64,   64,   39,   64,   41,   42,
 /*   640 */    43,   19,   20,   64,   64,   64,   24,   25,   26,   52,
 /*   650 */    28,   64,   30,   64,   57,   58,   59,   17,   64,   19,
 /*   660 */    20,   64,   64,   64,   24,   25,   26,   27,   28,   64,
 /*   670 */    30,   64,   17,   64,   19,   20,   64,   64,   64,   24,
 /*   680 */    25,   26,   27,   28,   36,   30,   36,   39,   64,   39,
 /*   690 */    42,   43,   42,   43,   19,   20,   46,   64,   64,   24,
 /*   700 */    25,   26,   27,   28,   54,   30,   58,   59,   58,   59,
 /*   710 */    64,   64,   36,   64,   64,   39,   64,   36,   42,   43,
 /*   720 */    39,   64,   36,   42,   43,   39,   64,   64,   42,   43,
 /*   730 */    36,   64,   64,   39,   58,   59,   42,   43,   64,   58,
 /*   740 */    59,   64,   64,   36,   58,   59,   39,   64,   64,   42,
 /*   750 */    43,   64,   58,   59,   64,   64,   64,   64,   64,   64,
 /*   760 */    64,   64,    9,   64,   11,   58,   59,   64,   15,   64,
 /*   770 */    64,    8,   19,   20,   11,    9,   64,   64,   15,   64,
 /*   780 */    11,   28,   19,   20,   15,   19,   20,   64,   19,   20,
 /*   790 */    64,   28,   64,   27,   28,   64,   64,   28,   64,   64,
 /*   800 */    64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
 /*   810 */    64,   64,   64,   64,   33,   33,   33,   33,   33,   33,
 /*   820 */    33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
 /*   830 */    33,
};
#define YY_SHIFT_COUNT    (120)
#define YY_SHIFT_MIN      (0)
#define YY_SHIFT_MAX      (769)
static const unsigned short int yy_shift_ofst[] = {
 /*     0 */    85,  217,    0,   27,   56,  112,  139,  166,  243,  243,
 /*    10 */   269,  269,  345,  345,  345,  345,  345,  345,  640,  640,
 /*    20 */   655,  655,  640,  640,  655,  655,  294,  191,  319,  370,
 /*    30 */   395,  395,  395,  395,  395,  395,  655,  655,  655,  675,
 /*    40 */   622,  675,  622,   41,  753,   20,   41,  763,  388,  388,
 /*    50 */   409,  766,  272,   49,   49,   49,   49,   49,   49,   49,
 /*    60 */    49,   49,   49,   36,    7,   36,    7,   36,    7,   36,
 /*    70 */    36,  769,   78,   78,   82,   82,  154,  152,   36,   11,
 /*    80 */   118,  227,   42,  151,  187,  101,  203,  263,  123,  231,
 /*    90 */   252,  283,  177,  214,  213,  238,  249,  261,  254,  264,
 /*   100 */   277,  257,  298,  265,  302,  290,  284,  303,  307,  289,
 /*   110 */   299,  300,  304,  305,  308,  315,  327,  322,  329,  313,
 /*   120 */   338,
};
#define YY_REDUCE_COUNT (78)
#define YY_REDUCE_MIN   (-53)
#define YY_REDUCE_MAX   (707)
static const short yy_reduce_ofst[] = {
 /*     0 */   391,  420,  447,  477,  447,  477,  447,  477,  447,  447,
 /*    10 */   477,  477,  489,  517,  529,  557,  569,  597,  447,  447,
 /*    20 */   477,  477,  447,  447,  477,  477,  650,  399,  399,  399,
 /*    30 */   648,  676,  681,  686,  694,  707,  399,  399,  399,  399,
 /*    40 */   415,  399,  456,  -49,   54,  -37,  -27,  -53,   81,   92,
 /*    50 */     4,   29,   61,   66,   88,  102,   61,  114,   61,  114,
 /*    60 */   120,  114,  130,  164,   31,  178,  176,  195,  186,  216,
 /*    70 */   230,  -45,   -8,  -45,   33,   69,   -4,  105,  173,
};
static const YYACTIONTYPE yy_default[] = {
 /*     0 */   277,  277,  277,  277,  277,  283,  290,  283,  291,  289,
 /*    10 */   292,  294,  277,  277,  277,  277,  277,  277,  315,  317,
 /*    20 */   318,  316,  284,  285,  287,  286,  277,  277,  295,  294,
 /*    30 */   277,  277,  277,  277,  277,  277,  318,  316,  287,  297,
 /*    40 */   277,  296,  277,  348,  277,  277,  347,  277,  277,  277,
 /*    50 */   277,  277,  277,  277,  277,  277,  337,  334,  333,  330,
 /*    60 */   277,  277,  277,  304,  277,  304,  277,  304,  277,  304,
 /*    70 */   304,  277,  277,  277,  277,  277,  277,  277,  303,  277,
 /*    80 */   277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
 /*    90 */   277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
 /*   100 */   277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
 /*   110 */   277,  277,  277,  277,  277,  367,  366,  277,  277,  293,
 /*   120 */   288,
};
/********** End of lemon-generated parsing tables *****************************/

/* The next table maps tokens (terminal symbols) into fallback tokens.  
** If a construct like the following:
** 
**      %fallback ID X Y Z.
**
** appears in the grammar, then ID becomes a fallback token for X, Y,
** and Z.  Whenever one of the tokens X, Y, or Z is input to the parser
** but it does not parse, the type of the token is changed to ID and
** the parse is retried before an error is thrown.
**
** This feature can be used, for example, to cause some keywords in a language
** to revert to identifiers if they keyword does not apply in the context where
** it appears.
*/
#ifdef YYFALLBACK
static const YYCODETYPE yyFallback[] = {
    0,  /*          $ => nothing */
    0,  /*     LOWEST => nothing */
    0,  /*   TEXTEXPR => nothing */
    0,  /*        ORX => nothing */
    0,  /*         OR => nothing */
    0,  /*   MODIFIER => nothing */
    0,  /*         RP => nothing */
    0,  /*         RB => nothing */
    0,  /*       RSQB => nothing */
    0,  /*       TERM => nothing */
    0,  /*      QUOTE => nothing */
    0,  /*         LP => nothing */
    0,  /*         LB => nothing */
    0,  /*       LSQB => nothing */
    0,  /*      TILDE => nothing */
    0,  /*      MINUS => nothing */
    0,  /*        AND => nothing */
    0,  /*      ARROW => nothing */
    0,  /*      COLON => nothing */
    0,  /*     NUMBER => nothing */
    0,  /*       SIZE => nothing */
    0,  /*       STAR => nothing */
    0,  /*    TAGLIST => nothing */
    0,  /*   TERMLIST => nothing */
    0,  /*     PREFIX => nothing */
    0,  /*     SUFFIX => nothing */
    0,  /*   CONTAINS => nothing */
    0,  /*    PERCENT => nothing */
    0,  /*  ATTRIBUTE => nothing */
    0,  /*   VERBATIM => nothing */
    0,  /*   WILDCARD => nothing */
    9,  /*       AS_T => TERM */
    0,  /*  SEMICOLON => nothing */
};
#endif /* YYFALLBACK */

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
**
** After the "shift" half of a SHIFTREDUCE action, the stateno field
** actually contains the reduce action for the second half of the
** SHIFTREDUCE.
*/
struct yyStackEntry {
  YYACTIONTYPE stateno;  /* The state-number, or reduce action in SHIFTREDUCE */
  YYCODETYPE major;      /* The major token value.  This is the code
                         ** number for the token at this stack level */
  YYMINORTYPE minor;     /* The user-supplied minor token value.  This
                         ** is the value of the token  */
};
typedef struct yyStackEntry yyStackEntry;

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  yyStackEntry *yytos;          /* Pointer to top element of the stack */
#ifdef YYTRACKMAXSTACKDEPTH
  int yyhwm;                    /* High-water mark of the stack */
#endif
#ifndef YYNOERRORRECOVERY
  int yyerrcnt;                 /* Shifts left before out of the error */
#endif
  RSQueryParser_v2_ARG_SDECL                /* A place to hold %extra_argument */
  RSQueryParser_v2_CTX_SDECL                /* A place to hold %extra_context */
#if YYSTACKDEPTH<=0
  int yystksz;                  /* Current side of the stack */
  yyStackEntry *yystack;        /* The parser's stack */
  yyStackEntry yystk0;          /* First stack entry */
#else
  yyStackEntry yystack[YYSTACKDEPTH];  /* The parser's stack */
  yyStackEntry *yystackEnd;            /* Last entry in the stack */
#endif
};
typedef struct yyParser yyParser;

#include <assert.h>
#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;
#endif /* NDEBUG */

#ifndef NDEBUG
/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void RSQueryParser_v2_Trace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}
#endif /* NDEBUG */

#if defined(YYCOVERAGE) || !defined(NDEBUG)
/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static const char *const yyTokenName[] = { 
  /*    0 */ "$",
  /*    1 */ "LOWEST",
  /*    2 */ "TEXTEXPR",
  /*    3 */ "ORX",
  /*    4 */ "OR",
  /*    5 */ "MODIFIER",
  /*    6 */ "RP",
  /*    7 */ "RB",
  /*    8 */ "RSQB",
  /*    9 */ "TERM",
  /*   10 */ "QUOTE",
  /*   11 */ "LP",
  /*   12 */ "LB",
  /*   13 */ "LSQB",
  /*   14 */ "TILDE",
  /*   15 */ "MINUS",
  /*   16 */ "AND",
  /*   17 */ "ARROW",
  /*   18 */ "COLON",
  /*   19 */ "NUMBER",
  /*   20 */ "SIZE",
  /*   21 */ "STAR",
  /*   22 */ "TAGLIST",
  /*   23 */ "TERMLIST",
  /*   24 */ "PREFIX",
  /*   25 */ "SUFFIX",
  /*   26 */ "CONTAINS",
  /*   27 */ "PERCENT",
  /*   28 */ "ATTRIBUTE",
  /*   29 */ "VERBATIM",
  /*   30 */ "WILDCARD",
  /*   31 */ "AS_T",
  /*   32 */ "SEMICOLON",
  /*   33 */ "expr",
  /*   34 */ "attribute",
  /*   35 */ "attribute_list",
  /*   36 */ "affix",
  /*   37 */ "suffix",
  /*   38 */ "contains",
  /*   39 */ "verbatim",
  /*   40 */ "termlist",
  /*   41 */ "union",
  /*   42 */ "text_union",
  /*   43 */ "text_expr",
  /*   44 */ "fuzzy",
  /*   45 */ "tag_list",
  /*   46 */ "geo_filter",
  /*   47 */ "vector_query",
  /*   48 */ "vector_command",
  /*   49 */ "vector_range_command",
  /*   50 */ "vector_attribute",
  /*   51 */ "vector_attribute_list",
  /*   52 */ "modifierlist",
  /*   53 */ "num",
  /*   54 */ "numeric_range",
  /*   55 */ "query",
  /*   56 */ "star",
  /*   57 */ "modifier",
  /*   58 */ "param_term",
  /*   59 */ "term",
  /*   60 */ "param_num",
  /*   61 */ "vector_score_field",
  /*   62 */ "as",
  /*   63 */ "param_size",
};
#endif /* defined(YYCOVERAGE) || !defined(NDEBUG) */

#ifndef NDEBUG
/* For tracing reduce actions, the names of all rules are required.
*/
static const char *const yyRuleName[] = {
 /*   0 */ "query ::= expr",
 /*   1 */ "query ::=",
 /*   2 */ "query ::= star",
 /*   3 */ "expr ::= text_expr",
 /*   4 */ "expr ::= expr expr",
 /*   5 */ "expr ::= text_expr expr",
 /*   6 */ "expr ::= expr text_expr",
 /*   7 */ "text_expr ::= text_expr text_expr",
 /*   8 */ "expr ::= union",
 /*   9 */ "union ::= expr OR expr",
 /*  10 */ "union ::= union OR expr",
 /*  11 */ "union ::= text_expr OR expr",
 /*  12 */ "union ::= expr OR text_expr",
 /*  13 */ "text_expr ::= text_union",
 /*  14 */ "text_union ::= text_expr OR text_expr",
 /*  15 */ "text_union ::= text_union OR text_expr",
 /*  16 */ "expr ::= modifier COLON text_expr",
 /*  17 */ "expr ::= modifierlist COLON text_expr",
 /*  18 */ "expr ::= LP expr RP",
 /*  19 */ "text_expr ::= LP text_expr RP",
 /*  20 */ "attribute ::= ATTRIBUTE COLON param_term",
 /*  21 */ "attribute_list ::= attribute",
 /*  22 */ "attribute_list ::= attribute_list SEMICOLON attribute",
 /*  23 */ "attribute_list ::= attribute_list SEMICOLON",
 /*  24 */ "attribute_list ::=",
 /*  25 */ "expr ::= expr ARROW LB attribute_list RB",
 /*  26 */ "text_expr ::= text_expr ARROW LB attribute_list RB",
 /*  27 */ "text_expr ::= QUOTE termlist QUOTE",
 /*  28 */ "text_expr ::= QUOTE term QUOTE",
 /*  29 */ "text_expr ::= QUOTE ATTRIBUTE QUOTE",
 /*  30 */ "text_expr ::= param_term",
 /*  31 */ "text_expr ::= affix",
 /*  32 */ "text_expr ::= verbatim",
 /*  33 */ "termlist ::= param_term param_term",
 /*  34 */ "termlist ::= termlist param_term",
 /*  35 */ "expr ::= MINUS expr",
 /*  36 */ "text_expr ::= MINUS text_expr",
 /*  37 */ "expr ::= TILDE expr",
 /*  38 */ "text_expr ::= TILDE text_expr",
 /*  39 */ "affix ::= PREFIX",
 /*  40 */ "affix ::= SUFFIX",
 /*  41 */ "affix ::= CONTAINS",
 /*  42 */ "verbatim ::= WILDCARD",
 /*  43 */ "text_expr ::= PERCENT param_term PERCENT",
 /*  44 */ "text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT",
 /*  45 */ "text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT",
 /*  46 */ "modifier ::= MODIFIER",
 /*  47 */ "modifierlist ::= modifier OR term",
 /*  48 */ "modifierlist ::= modifierlist OR term",
 /*  49 */ "expr ::= modifier COLON LB tag_list RB",
 /*  50 */ "tag_list ::= param_term",
 /*  51 */ "tag_list ::= affix",
 /*  52 */ "tag_list ::= verbatim",
 /*  53 */ "tag_list ::= termlist",
 /*  54 */ "tag_list ::= tag_list OR param_term",
 /*  55 */ "tag_list ::= tag_list OR affix",
 /*  56 */ "tag_list ::= tag_list OR verbatim",
 /*  57 */ "tag_list ::= tag_list OR termlist",
 /*  58 */ "expr ::= modifier COLON numeric_range",
 /*  59 */ "numeric_range ::= LSQB param_num param_num RSQB",
 /*  60 */ "expr ::= modifier COLON geo_filter",
 /*  61 */ "geo_filter ::= LSQB param_num param_num param_num param_term RSQB",
 /*  62 */ "query ::= expr ARROW LSQB vector_query RSQB",
 /*  63 */ "query ::= text_expr ARROW LSQB vector_query RSQB",
 /*  64 */ "query ::= star ARROW LSQB vector_query RSQB",
 /*  65 */ "vector_query ::= vector_command vector_attribute_list vector_score_field",
 /*  66 */ "vector_query ::= vector_command vector_score_field",
 /*  67 */ "vector_query ::= vector_command vector_attribute_list",
 /*  68 */ "vector_query ::= vector_command",
 /*  69 */ "vector_score_field ::= as param_term",
 /*  70 */ "query ::= expr ARROW LSQB vector_query RSQB ARROW LB attribute_list RB",
 /*  71 */ "query ::= text_expr ARROW LSQB vector_query RSQB ARROW LB attribute_list RB",
 /*  72 */ "query ::= star ARROW LSQB vector_query RSQB ARROW LB attribute_list RB",
 /*  73 */ "vector_command ::= TERM param_size modifier ATTRIBUTE",
 /*  74 */ "vector_attribute ::= TERM param_term",
 /*  75 */ "vector_attribute_list ::= vector_attribute_list vector_attribute",
 /*  76 */ "vector_attribute_list ::= vector_attribute",
 /*  77 */ "expr ::= modifier COLON LSQB vector_range_command RSQB",
 /*  78 */ "vector_range_command ::= TERM param_num ATTRIBUTE",
 /*  79 */ "num ::= SIZE",
 /*  80 */ "num ::= NUMBER",
 /*  81 */ "num ::= LP num",
 /*  82 */ "num ::= MINUS num",
 /*  83 */ "term ::= TERM",
 /*  84 */ "term ::= NUMBER",
 /*  85 */ "term ::= SIZE",
 /*  86 */ "param_term ::= term",
 /*  87 */ "param_term ::= ATTRIBUTE",
 /*  88 */ "param_size ::= SIZE",
 /*  89 */ "param_size ::= ATTRIBUTE",
 /*  90 */ "param_num ::= ATTRIBUTE",
 /*  91 */ "param_num ::= num",
 /*  92 */ "param_num ::= LP ATTRIBUTE",
 /*  93 */ "star ::= STAR",
 /*  94 */ "star ::= LP star RP",
 /*  95 */ "as ::= AS_T",
};
#endif /* NDEBUG */


#if YYSTACKDEPTH<=0
/*
** Try to increase the size of the parser stack.  Return the number
** of errors.  Return 0 on success.
*/
static int yyGrowStack(yyParser *p){
  int newSize;
  int idx;
  yyStackEntry *pNew;

  newSize = p->yystksz*2 + 100;
  idx = p->yytos ? (int)(p->yytos - p->yystack) : 0;
  if( p->yystack==&p->yystk0 ){
    pNew = malloc(newSize*sizeof(pNew[0]));
    if( pNew ) pNew[0] = p->yystk0;
  }else{
    pNew = realloc(p->yystack, newSize*sizeof(pNew[0]));
  }
  if( pNew ){
    p->yystack = pNew;
    p->yytos = &p->yystack[idx];
#ifndef NDEBUG
    if( yyTraceFILE ){
      fprintf(yyTraceFILE,"%sStack grows from %d to %d entries.\n",
              yyTracePrompt, p->yystksz, newSize);
    }
#endif
    p->yystksz = newSize;
  }
  return pNew==0; 
}
#endif

/* Datatype of the argument to the memory allocated passed as the
** second argument to RSQueryParser_v2_Alloc() below.  This can be changed by
** putting an appropriate #define in the %include section of the input
** grammar.
*/
#ifndef YYMALLOCARGTYPE
# define YYMALLOCARGTYPE size_t
#endif

/* Initialize a new parser that has already been allocated.
*/
void RSQueryParser_v2_Init(void *yypRawParser RSQueryParser_v2_CTX_PDECL){
  yyParser *yypParser = (yyParser*)yypRawParser;
  RSQueryParser_v2_CTX_STORE
#ifdef YYTRACKMAXSTACKDEPTH
  yypParser->yyhwm = 0;
#endif
#if YYSTACKDEPTH<=0
  yypParser->yytos = NULL;
  yypParser->yystack = NULL;
  yypParser->yystksz = 0;
  if( yyGrowStack(yypParser) ){
    yypParser->yystack = &yypParser->yystk0;
    yypParser->yystksz = 1;
  }
#endif
#ifndef YYNOERRORRECOVERY
  yypParser->yyerrcnt = -1;
#endif
  yypParser->yytos = yypParser->yystack;
  yypParser->yystack[0].stateno = 0;
  yypParser->yystack[0].major = 0;
#if YYSTACKDEPTH>0
  yypParser->yystackEnd = &yypParser->yystack[YYSTACKDEPTH-1];
#endif
}

#ifndef RSQueryParser_v2__ENGINEALWAYSONSTACK
/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to RSQueryParser_v2_ and RSQueryParser_v2_Free.
*/
void *RSQueryParser_v2_Alloc(void *(*mallocProc)(YYMALLOCARGTYPE) RSQueryParser_v2_CTX_PDECL){
  yyParser *yypParser;
  yypParser = (yyParser*)(*mallocProc)( (YYMALLOCARGTYPE)sizeof(yyParser) );
  if( yypParser ){
    RSQueryParser_v2_CTX_STORE
    RSQueryParser_v2_Init(yypParser RSQueryParser_v2_CTX_PARAM);
  }
  return (void*)yypParser;
}
#endif /* RSQueryParser_v2__ENGINEALWAYSONSTACK */


/* The following function deletes the "minor type" or semantic value
** associated with a symbol.  The symbol can be either a terminal
** or nonterminal. "yymajor" is the symbol code, and "yypminor" is
** a pointer to the value to be deleted.  The code used to do the 
** deletions is derived from the %destructor and/or %token_destructor
** directives of the input grammar.
*/
static void yy_destructor(
  yyParser *yypParser,    /* The parser */
  YYCODETYPE yymajor,     /* Type code for object to destroy */
  YYMINORTYPE *yypminor   /* The object to be destroyed */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are *not* used
    ** inside the C code.
    */
/********* Begin destructor definitions ***************************************/
      /* Default NON-TERMINAL Destructor */
    case 50: /* vector_attribute */
    case 53: /* num */
    case 55: /* query */
    case 56: /* star */
    case 57: /* modifier */
    case 58: /* param_term */
    case 59: /* term */
    case 60: /* param_num */
    case 61: /* vector_score_field */
    case 62: /* as */
    case 63: /* param_size */
{
 
}
      break;
    case 33: /* expr */
    case 36: /* affix */
    case 37: /* suffix */
    case 38: /* contains */
    case 39: /* verbatim */
    case 40: /* termlist */
    case 41: /* union */
    case 42: /* text_union */
    case 43: /* text_expr */
    case 44: /* fuzzy */
    case 45: /* tag_list */
    case 47: /* vector_query */
    case 48: /* vector_command */
    case 49: /* vector_range_command */
{
 QueryNode_Free((yypminor->yy51)); 
}
      break;
    case 34: /* attribute */
{
 rm_free((char*)(yypminor->yy7).value); 
}
      break;
    case 35: /* attribute_list */
{
 array_free_ex((yypminor->yy33), rm_free((char*)((QueryAttribute*)ptr )->value)); 
}
      break;
    case 46: /* geo_filter */
{
 QueryParam_Free((yypminor->yy30)); 
}
      break;
    case 51: /* vector_attribute_list */
{

  array_free((yypminor->yy10).needResolve);
  array_free_ex((yypminor->yy10).params, {
    rm_free((char*)((VecSimRawParam*)ptr)->value);
    rm_free((char*)((VecSimRawParam*)ptr)->name);
  });

}
      break;
    case 52: /* modifierlist */
{

    for (size_t i = 0; i < Vector_Size((yypminor->yy114)); i++) {
        char *s;
        Vector_Get((yypminor->yy114), i, &s);
        rm_free(s);
    }
    Vector_Free((yypminor->yy114));

}
      break;
    case 54: /* numeric_range */
{

  QueryParam_Free((yypminor->yy30));

}
      break;
/********* End destructor definitions *****************************************/
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
*/
static void yy_pop_parser_stack(yyParser *pParser){
  yyStackEntry *yytos;
  assert( pParser->yytos!=0 );
  assert( pParser->yytos > pParser->yystack );
  yytos = pParser->yytos--;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[yytos->major]);
  }
#endif
  yy_destructor(pParser, yytos->major, &yytos->minor);
}

/*
** Clear all secondary memory allocations from the parser
*/
void RSQueryParser_v2_Finalize(void *p){
  yyParser *pParser = (yyParser*)p;
  while( pParser->yytos>pParser->yystack ) yy_pop_parser_stack(pParser);
#if YYSTACKDEPTH<=0
  if( pParser->yystack!=&pParser->yystk0 ) free(pParser->yystack);
#endif
}

#ifndef RSQueryParser_v2__ENGINEALWAYSONSTACK
/* 
** Deallocate and destroy a parser.  Destructors are called for
** all stack elements before shutting the parser down.
**
** If the YYPARSEFREENEVERNULL macro exists (for example because it
** is defined in a %include section of the input grammar) then it is
** assumed that the input pointer is never NULL.
*/
void RSQueryParser_v2_Free(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
#ifndef YYPARSEFREENEVERNULL
  if( p==0 ) return;
#endif
  RSQueryParser_v2_Finalize(p);
  (*freeProc)(p);
}
#endif /* RSQueryParser_v2__ENGINEALWAYSONSTACK */

/*
** Return the peak depth of the stack for a parser.
*/
#ifdef YYTRACKMAXSTACKDEPTH
int RSQueryParser_v2_StackPeak(void *p){
  yyParser *pParser = (yyParser*)p;
  return pParser->yyhwm;
}
#endif

/* This array of booleans keeps track of the parser statement
** coverage.  The element yycoverage[X][Y] is set when the parser
** is in state X and has a lookahead token Y.  In a well-tested
** systems, every element of this matrix should end up being set.
*/
#if defined(YYCOVERAGE)
static unsigned char yycoverage[YYNSTATE][YYNTOKEN];
#endif

/*
** Write into out a description of every state/lookahead combination that
**
**   (1)  has not been used by the parser, and
**   (2)  is not a syntax error.
**
** Return the number of missed state/lookahead combinations.
*/
#if defined(YYCOVERAGE)
int RSQueryParser_v2_Coverage(FILE *out){
  int stateno, iLookAhead, i;
  int nMissed = 0;
  for(stateno=0; stateno<YYNSTATE; stateno++){
    i = yy_shift_ofst[stateno];
    for(iLookAhead=0; iLookAhead<YYNTOKEN; iLookAhead++){
      if( yy_lookahead[i+iLookAhead]!=iLookAhead ) continue;
      if( yycoverage[stateno][iLookAhead]==0 ) nMissed++;
      if( out ){
        fprintf(out,"State %d lookahead %s %s\n", stateno,
                yyTokenName[iLookAhead],
                yycoverage[stateno][iLookAhead] ? "ok" : "missed");
      }
    }
  }
  return nMissed;
}
#endif

/*
** Find the appropriate action for a parser given the terminal
** look-ahead token iLookAhead.
*/
static YYACTIONTYPE yy_find_shift_action(
  YYCODETYPE iLookAhead,    /* The look-ahead token */
  YYACTIONTYPE stateno      /* Current state number */
){
  int i;

  if( stateno>YY_MAX_SHIFT ) return stateno;
  assert( stateno <= YY_SHIFT_COUNT );
#if defined(YYCOVERAGE)
  yycoverage[stateno][iLookAhead] = 1;
#endif
  do{
    i = yy_shift_ofst[stateno];
    assert( i>=0 );
    assert( i<=YY_ACTTAB_COUNT );
    assert( i+YYNTOKEN<=(int)YY_NLOOKAHEAD );
    assert( iLookAhead!=YYNOCODE );
    assert( iLookAhead < YYNTOKEN );
    i += iLookAhead;
    assert( i<(int)YY_NLOOKAHEAD );
    if( yy_lookahead[i]!=iLookAhead ){
#ifdef YYFALLBACK
      YYCODETYPE iFallback;            /* Fallback token */
      assert( iLookAhead<sizeof(yyFallback)/sizeof(yyFallback[0]) );
      iFallback = yyFallback[iLookAhead];
      if( iFallback!=0 ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE, "%sFALLBACK %s => %s\n",
             yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[iFallback]);
        }
#endif
        assert( yyFallback[iFallback]==0 ); /* Fallback loop must terminate */
        iLookAhead = iFallback;
        continue;
      }
#endif
#ifdef YYWILDCARD
      {
        int j = i - iLookAhead + YYWILDCARD;
        assert( j<(int)(sizeof(yy_lookahead)/sizeof(yy_lookahead[0])) );
        if( yy_lookahead[j]==YYWILDCARD && iLookAhead>0 ){
#ifndef NDEBUG
          if( yyTraceFILE ){
            fprintf(yyTraceFILE, "%sWILDCARD %s => %s\n",
               yyTracePrompt, yyTokenName[iLookAhead],
               yyTokenName[YYWILDCARD]);
          }
#endif /* NDEBUG */
          return yy_action[j];
        }
      }
#endif /* YYWILDCARD */
      return yy_default[stateno];
    }else{
      assert( i>=0 && i<(int)(sizeof(yy_action)/sizeof(yy_action[0])) );
      return yy_action[i];
    }
  }while(1);
}

/*
** Find the appropriate action for a parser given the non-terminal
** look-ahead token iLookAhead.
*/
static YYACTIONTYPE yy_find_reduce_action(
  YYACTIONTYPE stateno,     /* Current state number */
  YYCODETYPE iLookAhead     /* The look-ahead token */
){
  int i;
#ifdef YYERRORSYMBOL
  if( stateno>YY_REDUCE_COUNT ){
    return yy_default[stateno];
  }
#else
  assert( stateno<=YY_REDUCE_COUNT );
#endif
  i = yy_reduce_ofst[stateno];
  assert( iLookAhead!=YYNOCODE );
  i += iLookAhead;
#ifdef YYERRORSYMBOL
  if( i<0 || i>=YY_ACTTAB_COUNT || yy_lookahead[i]!=iLookAhead ){
    return yy_default[stateno];
  }
#else
  assert( i>=0 && i<YY_ACTTAB_COUNT );
  assert( yy_lookahead[i]==iLookAhead );
#endif
  return yy_action[i];
}

/*
** The following routine is called if the stack overflows.
*/
static void yyStackOverflow(yyParser *yypParser){
   RSQueryParser_v2_ARG_FETCH
   RSQueryParser_v2_CTX_FETCH
#ifndef NDEBUG
   if( yyTraceFILE ){
     fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
   }
#endif
   while( yypParser->yytos>yypParser->yystack ) yy_pop_parser_stack(yypParser);
   /* Here code is inserted which will execute if the parser
   ** stack every overflows */
/******** Begin %stack_overflow code ******************************************/

  QueryError_SetErrorFmt(ctx->status, QUERY_ESYNTAX,
    "Parser stack overflow. Try moving nested parentheses more to the left");
/******** End %stack_overflow code ********************************************/
   RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument var */
   RSQueryParser_v2_CTX_STORE
}

/*
** Print tracing information for a SHIFT action
*/
#ifndef NDEBUG
static void yyTraceShift(yyParser *yypParser, int yyNewState, const char *zTag){
  if( yyTraceFILE ){
    if( yyNewState<YYNSTATE ){
      fprintf(yyTraceFILE,"%s%s '%s', go to state %d\n",
         yyTracePrompt, zTag, yyTokenName[yypParser->yytos->major],
         yyNewState);
    }else{
      fprintf(yyTraceFILE,"%s%s '%s', pending reduce %d\n",
         yyTracePrompt, zTag, yyTokenName[yypParser->yytos->major],
         yyNewState - YY_MIN_REDUCE);
    }
  }
}
#else
# define yyTraceShift(X,Y,Z)
#endif

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  YYACTIONTYPE yyNewState,      /* The new state to shift in */
  YYCODETYPE yyMajor,           /* The major token to shift in */
  RSQueryParser_v2_TOKENTYPE yyMinor        /* The minor token to shift in */
){
  yyStackEntry *yytos;
  yypParser->yytos++;
#ifdef YYTRACKMAXSTACKDEPTH
  if( (int)(yypParser->yytos - yypParser->yystack)>yypParser->yyhwm ){
    yypParser->yyhwm++;
    assert( yypParser->yyhwm == (int)(yypParser->yytos - yypParser->yystack) );
  }
#endif
#if YYSTACKDEPTH>0 
  if( yypParser->yytos>yypParser->yystackEnd ){
    yypParser->yytos--;
    yyStackOverflow(yypParser);
    return;
  }
#else
  if( yypParser->yytos>=&yypParser->yystack[yypParser->yystksz] ){
    if( yyGrowStack(yypParser) ){
      yypParser->yytos--;
      yyStackOverflow(yypParser);
      return;
    }
  }
#endif
  if( yyNewState > YY_MAX_SHIFT ){
    yyNewState += YY_MIN_REDUCE - YY_MIN_SHIFTREDUCE;
  }
  yytos = yypParser->yytos;
  yytos->stateno = yyNewState;
  yytos->major = yyMajor;
  yytos->minor.yy0 = yyMinor;
  yyTraceShift(yypParser, yyNewState, "Shift");
}

/* For rule J, yyRuleInfoLhs[J] contains the symbol on the left-hand side
** of that rule */
static const YYCODETYPE yyRuleInfoLhs[] = {
    55,  /* (0) query ::= expr */
    55,  /* (1) query ::= */
    55,  /* (2) query ::= star */
    33,  /* (3) expr ::= text_expr */
    33,  /* (4) expr ::= expr expr */
    33,  /* (5) expr ::= text_expr expr */
    33,  /* (6) expr ::= expr text_expr */
    43,  /* (7) text_expr ::= text_expr text_expr */
    33,  /* (8) expr ::= union */
    41,  /* (9) union ::= expr OR expr */
    41,  /* (10) union ::= union OR expr */
    41,  /* (11) union ::= text_expr OR expr */
    41,  /* (12) union ::= expr OR text_expr */
    43,  /* (13) text_expr ::= text_union */
    42,  /* (14) text_union ::= text_expr OR text_expr */
    42,  /* (15) text_union ::= text_union OR text_expr */
    33,  /* (16) expr ::= modifier COLON text_expr */
    33,  /* (17) expr ::= modifierlist COLON text_expr */
    33,  /* (18) expr ::= LP expr RP */
    43,  /* (19) text_expr ::= LP text_expr RP */
    34,  /* (20) attribute ::= ATTRIBUTE COLON param_term */
    35,  /* (21) attribute_list ::= attribute */
    35,  /* (22) attribute_list ::= attribute_list SEMICOLON attribute */
    35,  /* (23) attribute_list ::= attribute_list SEMICOLON */
    35,  /* (24) attribute_list ::= */
    33,  /* (25) expr ::= expr ARROW LB attribute_list RB */
    43,  /* (26) text_expr ::= text_expr ARROW LB attribute_list RB */
    43,  /* (27) text_expr ::= QUOTE termlist QUOTE */
    43,  /* (28) text_expr ::= QUOTE term QUOTE */
    43,  /* (29) text_expr ::= QUOTE ATTRIBUTE QUOTE */
    43,  /* (30) text_expr ::= param_term */
    43,  /* (31) text_expr ::= affix */
    43,  /* (32) text_expr ::= verbatim */
    40,  /* (33) termlist ::= param_term param_term */
    40,  /* (34) termlist ::= termlist param_term */
    33,  /* (35) expr ::= MINUS expr */
    43,  /* (36) text_expr ::= MINUS text_expr */
    33,  /* (37) expr ::= TILDE expr */
    43,  /* (38) text_expr ::= TILDE text_expr */
    36,  /* (39) affix ::= PREFIX */
    36,  /* (40) affix ::= SUFFIX */
    36,  /* (41) affix ::= CONTAINS */
    39,  /* (42) verbatim ::= WILDCARD */
    43,  /* (43) text_expr ::= PERCENT param_term PERCENT */
    43,  /* (44) text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
    43,  /* (45) text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
    57,  /* (46) modifier ::= MODIFIER */
    52,  /* (47) modifierlist ::= modifier OR term */
    52,  /* (48) modifierlist ::= modifierlist OR term */
    33,  /* (49) expr ::= modifier COLON LB tag_list RB */
    45,  /* (50) tag_list ::= param_term */
    45,  /* (51) tag_list ::= affix */
    45,  /* (52) tag_list ::= verbatim */
    45,  /* (53) tag_list ::= termlist */
    45,  /* (54) tag_list ::= tag_list OR param_term */
    45,  /* (55) tag_list ::= tag_list OR affix */
    45,  /* (56) tag_list ::= tag_list OR verbatim */
    45,  /* (57) tag_list ::= tag_list OR termlist */
    33,  /* (58) expr ::= modifier COLON numeric_range */
    54,  /* (59) numeric_range ::= LSQB param_num param_num RSQB */
    33,  /* (60) expr ::= modifier COLON geo_filter */
    46,  /* (61) geo_filter ::= LSQB param_num param_num param_num param_term RSQB */
    55,  /* (62) query ::= expr ARROW LSQB vector_query RSQB */
    55,  /* (63) query ::= text_expr ARROW LSQB vector_query RSQB */
    55,  /* (64) query ::= star ARROW LSQB vector_query RSQB */
    47,  /* (65) vector_query ::= vector_command vector_attribute_list vector_score_field */
    47,  /* (66) vector_query ::= vector_command vector_score_field */
    47,  /* (67) vector_query ::= vector_command vector_attribute_list */
    47,  /* (68) vector_query ::= vector_command */
    61,  /* (69) vector_score_field ::= as param_term */
    55,  /* (70) query ::= expr ARROW LSQB vector_query RSQB ARROW LB attribute_list RB */
    55,  /* (71) query ::= text_expr ARROW LSQB vector_query RSQB ARROW LB attribute_list RB */
    55,  /* (72) query ::= star ARROW LSQB vector_query RSQB ARROW LB attribute_list RB */
    48,  /* (73) vector_command ::= TERM param_size modifier ATTRIBUTE */
    50,  /* (74) vector_attribute ::= TERM param_term */
    51,  /* (75) vector_attribute_list ::= vector_attribute_list vector_attribute */
    51,  /* (76) vector_attribute_list ::= vector_attribute */
    33,  /* (77) expr ::= modifier COLON LSQB vector_range_command RSQB */
    49,  /* (78) vector_range_command ::= TERM param_num ATTRIBUTE */
    53,  /* (79) num ::= SIZE */
    53,  /* (80) num ::= NUMBER */
    53,  /* (81) num ::= LP num */
    53,  /* (82) num ::= MINUS num */
    59,  /* (83) term ::= TERM */
    59,  /* (84) term ::= NUMBER */
    59,  /* (85) term ::= SIZE */
    58,  /* (86) param_term ::= term */
    58,  /* (87) param_term ::= ATTRIBUTE */
    63,  /* (88) param_size ::= SIZE */
    63,  /* (89) param_size ::= ATTRIBUTE */
    60,  /* (90) param_num ::= ATTRIBUTE */
    60,  /* (91) param_num ::= num */
    60,  /* (92) param_num ::= LP ATTRIBUTE */
    56,  /* (93) star ::= STAR */
    56,  /* (94) star ::= LP star RP */
    62,  /* (95) as ::= AS_T */
};

/* For rule J, yyRuleInfoNRhs[J] contains the negative of the number
** of symbols on the right-hand side of that rule. */
static const signed char yyRuleInfoNRhs[] = {
   -1,  /* (0) query ::= expr */
    0,  /* (1) query ::= */
   -1,  /* (2) query ::= star */
   -1,  /* (3) expr ::= text_expr */
   -2,  /* (4) expr ::= expr expr */
   -2,  /* (5) expr ::= text_expr expr */
   -2,  /* (6) expr ::= expr text_expr */
   -2,  /* (7) text_expr ::= text_expr text_expr */
   -1,  /* (8) expr ::= union */
   -3,  /* (9) union ::= expr OR expr */
   -3,  /* (10) union ::= union OR expr */
   -3,  /* (11) union ::= text_expr OR expr */
   -3,  /* (12) union ::= expr OR text_expr */
   -1,  /* (13) text_expr ::= text_union */
   -3,  /* (14) text_union ::= text_expr OR text_expr */
   -3,  /* (15) text_union ::= text_union OR text_expr */
   -3,  /* (16) expr ::= modifier COLON text_expr */
   -3,  /* (17) expr ::= modifierlist COLON text_expr */
   -3,  /* (18) expr ::= LP expr RP */
   -3,  /* (19) text_expr ::= LP text_expr RP */
   -3,  /* (20) attribute ::= ATTRIBUTE COLON param_term */
   -1,  /* (21) attribute_list ::= attribute */
   -3,  /* (22) attribute_list ::= attribute_list SEMICOLON attribute */
   -2,  /* (23) attribute_list ::= attribute_list SEMICOLON */
    0,  /* (24) attribute_list ::= */
   -5,  /* (25) expr ::= expr ARROW LB attribute_list RB */
   -5,  /* (26) text_expr ::= text_expr ARROW LB attribute_list RB */
   -3,  /* (27) text_expr ::= QUOTE termlist QUOTE */
   -3,  /* (28) text_expr ::= QUOTE term QUOTE */
   -3,  /* (29) text_expr ::= QUOTE ATTRIBUTE QUOTE */
   -1,  /* (30) text_expr ::= param_term */
   -1,  /* (31) text_expr ::= affix */
   -1,  /* (32) text_expr ::= verbatim */
   -2,  /* (33) termlist ::= param_term param_term */
   -2,  /* (34) termlist ::= termlist param_term */
   -2,  /* (35) expr ::= MINUS expr */
   -2,  /* (36) text_expr ::= MINUS text_expr */
   -2,  /* (37) expr ::= TILDE expr */
   -2,  /* (38) text_expr ::= TILDE text_expr */
   -1,  /* (39) affix ::= PREFIX */
   -1,  /* (40) affix ::= SUFFIX */
   -1,  /* (41) affix ::= CONTAINS */
   -1,  /* (42) verbatim ::= WILDCARD */
   -3,  /* (43) text_expr ::= PERCENT param_term PERCENT */
   -5,  /* (44) text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
   -7,  /* (45) text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
   -1,  /* (46) modifier ::= MODIFIER */
   -3,  /* (47) modifierlist ::= modifier OR term */
   -3,  /* (48) modifierlist ::= modifierlist OR term */
   -5,  /* (49) expr ::= modifier COLON LB tag_list RB */
   -1,  /* (50) tag_list ::= param_term */
   -1,  /* (51) tag_list ::= affix */
   -1,  /* (52) tag_list ::= verbatim */
   -1,  /* (53) tag_list ::= termlist */
   -3,  /* (54) tag_list ::= tag_list OR param_term */
   -3,  /* (55) tag_list ::= tag_list OR affix */
   -3,  /* (56) tag_list ::= tag_list OR verbatim */
   -3,  /* (57) tag_list ::= tag_list OR termlist */
   -3,  /* (58) expr ::= modifier COLON numeric_range */
   -4,  /* (59) numeric_range ::= LSQB param_num param_num RSQB */
   -3,  /* (60) expr ::= modifier COLON geo_filter */
   -6,  /* (61) geo_filter ::= LSQB param_num param_num param_num param_term RSQB */
   -5,  /* (62) query ::= expr ARROW LSQB vector_query RSQB */
   -5,  /* (63) query ::= text_expr ARROW LSQB vector_query RSQB */
   -5,  /* (64) query ::= star ARROW LSQB vector_query RSQB */
   -3,  /* (65) vector_query ::= vector_command vector_attribute_list vector_score_field */
   -2,  /* (66) vector_query ::= vector_command vector_score_field */
   -2,  /* (67) vector_query ::= vector_command vector_attribute_list */
   -1,  /* (68) vector_query ::= vector_command */
   -2,  /* (69) vector_score_field ::= as param_term */
   -9,  /* (70) query ::= expr ARROW LSQB vector_query RSQB ARROW LB attribute_list RB */
   -9,  /* (71) query ::= text_expr ARROW LSQB vector_query RSQB ARROW LB attribute_list RB */
   -9,  /* (72) query ::= star ARROW LSQB vector_query RSQB ARROW LB attribute_list RB */
   -4,  /* (73) vector_command ::= TERM param_size modifier ATTRIBUTE */
   -2,  /* (74) vector_attribute ::= TERM param_term */
   -2,  /* (75) vector_attribute_list ::= vector_attribute_list vector_attribute */
   -1,  /* (76) vector_attribute_list ::= vector_attribute */
   -5,  /* (77) expr ::= modifier COLON LSQB vector_range_command RSQB */
   -3,  /* (78) vector_range_command ::= TERM param_num ATTRIBUTE */
   -1,  /* (79) num ::= SIZE */
   -1,  /* (80) num ::= NUMBER */
   -2,  /* (81) num ::= LP num */
   -2,  /* (82) num ::= MINUS num */
   -1,  /* (83) term ::= TERM */
   -1,  /* (84) term ::= NUMBER */
   -1,  /* (85) term ::= SIZE */
   -1,  /* (86) param_term ::= term */
   -1,  /* (87) param_term ::= ATTRIBUTE */
   -1,  /* (88) param_size ::= SIZE */
   -1,  /* (89) param_size ::= ATTRIBUTE */
   -1,  /* (90) param_num ::= ATTRIBUTE */
   -1,  /* (91) param_num ::= num */
   -2,  /* (92) param_num ::= LP ATTRIBUTE */
   -1,  /* (93) star ::= STAR */
   -3,  /* (94) star ::= LP star RP */
   -1,  /* (95) as ::= AS_T */
};

static void yy_accept(yyParser*);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
**
** The yyLookahead and yyLookaheadToken parameters provide reduce actions
** access to the lookahead token (if any).  The yyLookahead will be YYNOCODE
** if the lookahead token has already been consumed.  As this procedure is
** only called from one place, optimizing compilers will in-line it, which
** means that the extra parameters have no performance impact.
*/
static YYACTIONTYPE yy_reduce(
  yyParser *yypParser,         /* The parser */
  unsigned int yyruleno,       /* Number of the rule by which to reduce */
  int yyLookahead,             /* Lookahead token, or YYNOCODE if none */
  RSQueryParser_v2_TOKENTYPE yyLookaheadToken  /* Value of the lookahead token */
  RSQueryParser_v2_CTX_PDECL                   /* %extra_context */
){
  int yygoto;                     /* The next state */
  YYACTIONTYPE yyact;             /* The next action */
  yyStackEntry *yymsp;            /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  RSQueryParser_v2_ARG_FETCH
  (void)yyLookahead;
  (void)yyLookaheadToken;
  yymsp = yypParser->yytos;

  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
/********** Begin reduce actions **********************************************/
        YYMINORTYPE yylhsminor;
      case 0: /* query ::= expr */
{
  setup_trace(ctx);
  ctx->root = yymsp[0].minor.yy51;
}
        break;
      case 1: /* query ::= */
{
  ctx->root = NULL;
}
        break;
      case 2: /* query ::= star */
{  yy_destructor(yypParser,56,&yymsp[0].minor);
{
  setup_trace(ctx);
  ctx->root = NewWildcardNode();
}
}
        break;
      case 3: /* expr ::= text_expr */
      case 8: /* expr ::= union */ yytestcase(yyruleno==8);
      case 13: /* text_expr ::= text_union */ yytestcase(yyruleno==13);
      case 68: /* vector_query ::= vector_command */ yytestcase(yyruleno==68);
{
  yylhsminor.yy51 = yymsp[0].minor.yy51;
}
  yymsp[0].minor.yy51 = yylhsminor.yy51;
        break;
      case 4: /* expr ::= expr expr */
      case 5: /* expr ::= text_expr expr */ yytestcase(yyruleno==5);
      case 6: /* expr ::= expr text_expr */ yytestcase(yyruleno==6);
      case 7: /* text_expr ::= text_expr text_expr */ yytestcase(yyruleno==7);
{
    int rv = one_not_null(yymsp[-1].minor.yy51, yymsp[0].minor.yy51, (void**)&yylhsminor.yy51);
    if (rv == NODENN_BOTH_INVALID) {
        yylhsminor.yy51 = NULL;
    } else if (rv == NODENN_ONE_NULL) {
        // Nothing- `out` is already assigned
    } else {
        if (yymsp[-1].minor.yy51 && yymsp[-1].minor.yy51->type == QN_PHRASE && yymsp[-1].minor.yy51->pn.exact == 0 &&
            yymsp[-1].minor.yy51->opts.fieldMask == RS_FIELDMASK_ALL ) {
            yylhsminor.yy51 = yymsp[-1].minor.yy51;
        } else {
            yylhsminor.yy51 = NewPhraseNode(0);
            QueryNode_AddChild(yylhsminor.yy51, yymsp[-1].minor.yy51);
        }
        QueryNode_AddChild(yylhsminor.yy51, yymsp[0].minor.yy51);
    }
}
  yymsp[-1].minor.yy51 = yylhsminor.yy51;
        break;
      case 9: /* union ::= expr OR expr */
      case 11: /* union ::= text_expr OR expr */ yytestcase(yyruleno==11);
      case 12: /* union ::= expr OR text_expr */ yytestcase(yyruleno==12);
      case 14: /* text_union ::= text_expr OR text_expr */ yytestcase(yyruleno==14);
{
    int rv = one_not_null(yymsp[-2].minor.yy51, yymsp[0].minor.yy51, (void**)&yylhsminor.yy51);
    if (rv == NODENN_BOTH_INVALID) {
        yylhsminor.yy51 = NULL;
    } else if (rv == NODENN_ONE_NULL) {
        // Nothing- already assigned
    } else {
        if (yymsp[-2].minor.yy51->type == QN_UNION && yymsp[-2].minor.yy51->opts.fieldMask == RS_FIELDMASK_ALL) {
            yylhsminor.yy51 = yymsp[-2].minor.yy51;
        } else {
            yylhsminor.yy51 = NewUnionNode();
            QueryNode_AddChild(yylhsminor.yy51, yymsp[-2].minor.yy51);
            yylhsminor.yy51->opts.fieldMask |= yymsp[-2].minor.yy51->opts.fieldMask;
        }
        // Handle yymsp[0].minor.yy51
        QueryNode_AddChild(yylhsminor.yy51, yymsp[0].minor.yy51);
        yylhsminor.yy51->opts.fieldMask |= yymsp[0].minor.yy51->opts.fieldMask;
        QueryNode_SetFieldMask(yylhsminor.yy51, yylhsminor.yy51->opts.fieldMask);
    }
}
  yymsp[-2].minor.yy51 = yylhsminor.yy51;
        break;
      case 10: /* union ::= union OR expr */
      case 15: /* text_union ::= text_union OR text_expr */ yytestcase(yyruleno==15);
{
    yylhsminor.yy51 = yymsp[-2].minor.yy51;
    if (yymsp[0].minor.yy51) {
        QueryNode_AddChild(yylhsminor.yy51, yymsp[0].minor.yy51);
        yylhsminor.yy51->opts.fieldMask |= yymsp[0].minor.yy51->opts.fieldMask;
        QueryNode_SetFieldMask(yymsp[0].minor.yy51, yylhsminor.yy51->opts.fieldMask);
    }
}
  yymsp[-2].minor.yy51 = yylhsminor.yy51;
        break;
      case 16: /* expr ::= modifier COLON text_expr */
{
    if (yymsp[0].minor.yy51 == NULL) {
        yylhsminor.yy51 = NULL;
    } else {
        if (ctx->sctx->spec) {
            QueryNode_SetFieldMask(yymsp[0].minor.yy51, IndexSpec_GetFieldBit(ctx->sctx->spec, yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len));
        }
        yylhsminor.yy51 = yymsp[0].minor.yy51;
    }
}
  yymsp[-2].minor.yy51 = yylhsminor.yy51;
        break;
      case 17: /* expr ::= modifierlist COLON text_expr */
{

    if (yymsp[0].minor.yy51 == NULL) {
        for (size_t i = 0; i < Vector_Size(yymsp[-2].minor.yy114); i++) {
          char *s;
          Vector_Get(yymsp[-2].minor.yy114, i, &s);
          rm_free(s);
        }
        Vector_Free(yymsp[-2].minor.yy114);
        yylhsminor.yy51 = NULL;
    } else {
        //yymsp[0].minor.yy51->opts.fieldMask = 0;
        t_fieldMask mask = 0;
        for (int i = 0; i < Vector_Size(yymsp[-2].minor.yy114); i++) {
            char *p;
            Vector_Get(yymsp[-2].minor.yy114, i, &p);
            if (ctx->sctx->spec) {
              mask |= IndexSpec_GetFieldBit(ctx->sctx->spec, p, strlen(p));
            }
            rm_free(p);
        }
        Vector_Free(yymsp[-2].minor.yy114);
        QueryNode_SetFieldMask(yymsp[0].minor.yy51, mask);
        yylhsminor.yy51=yymsp[0].minor.yy51;
    }
}
  yymsp[-2].minor.yy51 = yylhsminor.yy51;
        break;
      case 18: /* expr ::= LP expr RP */
      case 19: /* text_expr ::= LP text_expr RP */ yytestcase(yyruleno==19);
{
  yymsp[-2].minor.yy51 = yymsp[-1].minor.yy51;
}
        break;
      case 20: /* attribute ::= ATTRIBUTE COLON param_term */
{
  const char *value = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
  size_t value_len = yymsp[0].minor.yy0.len;
  if (yymsp[0].minor.yy0.type == QT_PARAM_TERM) {
    size_t found_value_len;
    const char *found_value = Param_DictGet(ctx->opts->params, value, &found_value_len, ctx->status);
    if (found_value) {
      rm_free((char*)value);
      value = rm_strndup(found_value, found_value_len);
      value_len = found_value_len;
    }
  }
  yylhsminor.yy7 = (QueryAttribute){ .name = yymsp[-2].minor.yy0.s, .namelen = yymsp[-2].minor.yy0.len, .value = value, .vallen = value_len };
}
  yymsp[-2].minor.yy7 = yylhsminor.yy7;
        break;
      case 21: /* attribute_list ::= attribute */
{
  yylhsminor.yy33 = array_new(QueryAttribute, 2);
  yylhsminor.yy33 = array_append(yylhsminor.yy33, yymsp[0].minor.yy7);
}
  yymsp[0].minor.yy33 = yylhsminor.yy33;
        break;
      case 22: /* attribute_list ::= attribute_list SEMICOLON attribute */
{
  yylhsminor.yy33 = array_append(yymsp[-2].minor.yy33, yymsp[0].minor.yy7);
}
  yymsp[-2].minor.yy33 = yylhsminor.yy33;
        break;
      case 23: /* attribute_list ::= attribute_list SEMICOLON */
{
  yylhsminor.yy33 = yymsp[-1].minor.yy33;
}
  yymsp[-1].minor.yy33 = yylhsminor.yy33;
        break;
      case 24: /* attribute_list ::= */
{
  yymsp[1].minor.yy33 = NULL;
}
        break;
      case 25: /* expr ::= expr ARROW LB attribute_list RB */
      case 26: /* text_expr ::= text_expr ARROW LB attribute_list RB */ yytestcase(yyruleno==26);
{

    if (yymsp[-4].minor.yy51 && yymsp[-1].minor.yy33) {
        QueryNode_ApplyAttributes(yymsp[-4].minor.yy51, yymsp[-1].minor.yy33, array_len(yymsp[-1].minor.yy33), ctx->status);
    }
    array_free_ex(yymsp[-1].minor.yy33, rm_free((char*)((QueryAttribute*)ptr )->value));
    yylhsminor.yy51 = yymsp[-4].minor.yy51;
}
  yymsp[-4].minor.yy51 = yylhsminor.yy51;
        break;
      case 27: /* text_expr ::= QUOTE termlist QUOTE */
{
  // TODO: Quoted/verbatim string in termlist should not be handled as parameters
  // Also need to add the leading '$' which was consumed by the lexer
  yymsp[-1].minor.yy51->pn.exact = 1;
  yymsp[-1].minor.yy51->opts.flags |= QueryNode_Verbatim;

  yymsp[-2].minor.yy51 = yymsp[-1].minor.yy51;
}
        break;
      case 28: /* text_expr ::= QUOTE term QUOTE */
{
  yymsp[-2].minor.yy51 = NewTokenNode(ctx, rm_strdupcase(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len), -1);
  yymsp[-2].minor.yy51->opts.flags |= QueryNode_Verbatim;
}
        break;
      case 29: /* text_expr ::= QUOTE ATTRIBUTE QUOTE */
{
  // Quoted/verbatim string should not be handled as parameters
  // Also need to add the leading '$' which was consumed by the lexer
  char *s = rm_malloc(yymsp[-1].minor.yy0.len + 1);
  *s = '$';
  memcpy(s + 1, yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
  yymsp[-2].minor.yy51 = NewTokenNode(ctx, rm_strdupcase(s, yymsp[-1].minor.yy0.len + 1), -1);
  rm_free(s);
  yymsp[-2].minor.yy51->opts.flags |= QueryNode_Verbatim;
}
        break;
      case 30: /* text_expr ::= param_term */
{
  if (yymsp[0].minor.yy0.type == QT_TERM && StopWordList_Contains(ctx->opts->stopwords, yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len)) {
    yylhsminor.yy51 = NULL;
  } else {
    yylhsminor.yy51 = NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0);
  }
}
  yymsp[0].minor.yy51 = yylhsminor.yy51;
        break;
      case 31: /* text_expr ::= affix */
      case 32: /* text_expr ::= verbatim */ yytestcase(yyruleno==32);
{
yylhsminor.yy51 = yymsp[0].minor.yy51;
}
  yymsp[0].minor.yy51 = yylhsminor.yy51;
        break;
      case 33: /* termlist ::= param_term param_term */
{
  yylhsminor.yy51 = NewPhraseNode(0);
  QueryNode_AddChild(yylhsminor.yy51, NewTokenNode_WithParams(ctx, &yymsp[-1].minor.yy0));
  QueryNode_AddChild(yylhsminor.yy51, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
}
  yymsp[-1].minor.yy51 = yylhsminor.yy51;
        break;
      case 34: /* termlist ::= termlist param_term */
{
    yylhsminor.yy51 = yymsp[-1].minor.yy51;
    if (!(yymsp[0].minor.yy0.type == QT_TERM && StopWordList_Contains(ctx->opts->stopwords, yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len))) {
       QueryNode_AddChild(yylhsminor.yy51, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
    }
}
  yymsp[-1].minor.yy51 = yylhsminor.yy51;
        break;
      case 35: /* expr ::= MINUS expr */
      case 36: /* text_expr ::= MINUS text_expr */ yytestcase(yyruleno==36);
{
    if (yymsp[0].minor.yy51) {
        yymsp[-1].minor.yy51 = NewNotNode(yymsp[0].minor.yy51);
    } else {
        yymsp[-1].minor.yy51 = NULL;
    }
}
        break;
      case 37: /* expr ::= TILDE expr */
      case 38: /* text_expr ::= TILDE text_expr */ yytestcase(yyruleno==38);
{
    if (yymsp[0].minor.yy51) {
        yymsp[-1].minor.yy51 = NewOptionalNode(yymsp[0].minor.yy51);
    } else {
        yymsp[-1].minor.yy51 = NULL;
    }
}
        break;
      case 39: /* affix ::= PREFIX */
{
    yylhsminor.yy51 = NewPrefixNode_WithParams(ctx, &yymsp[0].minor.yy0, true, false);
}
  yymsp[0].minor.yy51 = yylhsminor.yy51;
        break;
      case 40: /* affix ::= SUFFIX */
{
    yylhsminor.yy51 = NewPrefixNode_WithParams(ctx, &yymsp[0].minor.yy0, false, true);
}
  yymsp[0].minor.yy51 = yylhsminor.yy51;
        break;
      case 41: /* affix ::= CONTAINS */
{
    yylhsminor.yy51 = NewPrefixNode_WithParams(ctx, &yymsp[0].minor.yy0, true, true);
}
  yymsp[0].minor.yy51 = yylhsminor.yy51;
        break;
      case 42: /* verbatim ::= WILDCARD */
{
    yylhsminor.yy51 = NewWildcardNode_WithParams(ctx, &yymsp[0].minor.yy0);
}
  yymsp[0].minor.yy51 = yylhsminor.yy51;
        break;
      case 43: /* text_expr ::= PERCENT param_term PERCENT */
{
  yymsp[-2].minor.yy51 = NewFuzzyNode_WithParams(ctx, &yymsp[-1].minor.yy0, 1);
}
        break;
      case 44: /* text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
{
  yymsp[-4].minor.yy51 = NewFuzzyNode_WithParams(ctx, &yymsp[-2].minor.yy0, 2);
}
        break;
      case 45: /* text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
{
  yymsp[-6].minor.yy51 = NewFuzzyNode_WithParams(ctx, &yymsp[-3].minor.yy0, 3);
}
        break;
      case 46: /* modifier ::= MODIFIER */
{
    yymsp[0].minor.yy0.len = unescapen((char*)yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    yylhsminor.yy0 = yymsp[0].minor.yy0;
 }
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 47: /* modifierlist ::= modifier OR term */
{
    yylhsminor.yy114 = NewVector(char *, 2);
    char *s = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    Vector_Push(yylhsminor.yy114, s);
    s = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    Vector_Push(yylhsminor.yy114, s);
}
  yymsp[-2].minor.yy114 = yylhsminor.yy114;
        break;
      case 48: /* modifierlist ::= modifierlist OR term */
{
    char *s = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    Vector_Push(yymsp[-2].minor.yy114, s);
    yylhsminor.yy114 = yymsp[-2].minor.yy114;
}
  yymsp[-2].minor.yy114 = yylhsminor.yy114;
        break;
      case 49: /* expr ::= modifier COLON LB tag_list RB */
{
    if (!yymsp[-1].minor.yy51) {
        yylhsminor.yy51 = NULL;
    } else {
      // Tag field names must be case sensitive, we can't do rm_strdupcase
        char *s = rm_strndup(yymsp[-4].minor.yy0.s, yymsp[-4].minor.yy0.len);
        size_t slen = unescapen((char*)s, yymsp[-4].minor.yy0.len);

        yylhsminor.yy51 = NewTagNode(s, slen);
        QueryNode_AddChildren(yylhsminor.yy51, yymsp[-1].minor.yy51->children, QueryNode_NumChildren(yymsp[-1].minor.yy51));

        // Set the children count on yymsp[-1].minor.yy51 to 0 so they won't get recursively free'd
        QueryNode_ClearChildren(yymsp[-1].minor.yy51, 0);
        QueryNode_Free(yymsp[-1].minor.yy51);
    }
}
  yymsp[-4].minor.yy51 = yylhsminor.yy51;
        break;
      case 50: /* tag_list ::= param_term */
{
  yylhsminor.yy51 = NewPhraseNode(0);
  if (yymsp[0].minor.yy0.type == QT_TERM)
    yymsp[0].minor.yy0.type = QT_TERM_CASE;
  else if (yymsp[0].minor.yy0.type == QT_PARAM_TERM)
    yymsp[0].minor.yy0.type = QT_PARAM_TERM_CASE;
  QueryNode_AddChild(yylhsminor.yy51, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
}
  yymsp[0].minor.yy51 = yylhsminor.yy51;
        break;
      case 51: /* tag_list ::= affix */
      case 52: /* tag_list ::= verbatim */ yytestcase(yyruleno==52);
      case 53: /* tag_list ::= termlist */ yytestcase(yyruleno==53);
{
    yylhsminor.yy51 = NewPhraseNode(0);
    QueryNode_AddChild(yylhsminor.yy51, yymsp[0].minor.yy51);
}
  yymsp[0].minor.yy51 = yylhsminor.yy51;
        break;
      case 54: /* tag_list ::= tag_list OR param_term */
{
  if (yymsp[0].minor.yy0.type == QT_TERM)
    yymsp[0].minor.yy0.type = QT_TERM_CASE;
  else if (yymsp[0].minor.yy0.type == QT_PARAM_TERM)
    yymsp[0].minor.yy0.type = QT_PARAM_TERM_CASE;
  QueryNode_AddChild(yymsp[-2].minor.yy51, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
  yylhsminor.yy51 = yymsp[-2].minor.yy51;
}
  yymsp[-2].minor.yy51 = yylhsminor.yy51;
        break;
      case 55: /* tag_list ::= tag_list OR affix */
      case 56: /* tag_list ::= tag_list OR verbatim */ yytestcase(yyruleno==56);
      case 57: /* tag_list ::= tag_list OR termlist */ yytestcase(yyruleno==57);
{
    QueryNode_AddChild(yymsp[-2].minor.yy51, yymsp[0].minor.yy51);
    yylhsminor.yy51 = yymsp[-2].minor.yy51;
}
  yymsp[-2].minor.yy51 = yylhsminor.yy51;
        break;
      case 58: /* expr ::= modifier COLON numeric_range */
{
  if (yymsp[0].minor.yy30) {
    // we keep the capitalization as is
    yymsp[0].minor.yy30->nf->fieldName = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    yylhsminor.yy51 = NewNumericNode(yymsp[0].minor.yy30);
  } else {
    yylhsminor.yy51 = NewQueryNode(QN_NULL);
  }
}
  yymsp[-2].minor.yy51 = yylhsminor.yy51;
        break;
      case 59: /* numeric_range ::= LSQB param_num param_num RSQB */
{
  if (yymsp[-2].minor.yy0.type == QT_PARAM_NUMERIC) {
    yymsp[-2].minor.yy0.type = QT_PARAM_NUMERIC_MIN_RANGE;
  }
  if (yymsp[-1].minor.yy0.type == QT_PARAM_NUMERIC) {
    yymsp[-1].minor.yy0.type = QT_PARAM_NUMERIC_MAX_RANGE;
  }
  yymsp[-3].minor.yy30 = NewNumericFilterQueryParam_WithParams(ctx, &yymsp[-2].minor.yy0, &yymsp[-1].minor.yy0, yymsp[-2].minor.yy0.inclusive, yymsp[-1].minor.yy0.inclusive);
}
        break;
      case 60: /* expr ::= modifier COLON geo_filter */
{
  if (yymsp[0].minor.yy30) {
    // we keep the capitalization as is
    yymsp[0].minor.yy30->gf->property = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    yylhsminor.yy51 = NewGeofilterNode(yymsp[0].minor.yy30);
  } else {
    yylhsminor.yy51 = NewQueryNode(QN_NULL);
  }
}
  yymsp[-2].minor.yy51 = yylhsminor.yy51;
        break;
      case 61: /* geo_filter ::= LSQB param_num param_num param_num param_term RSQB */
{
  if (yymsp[-4].minor.yy0.type == QT_PARAM_NUMERIC)
    yymsp[-4].minor.yy0.type = QT_PARAM_GEO_COORD;
  if (yymsp[-3].minor.yy0.type == QT_PARAM_NUMERIC)
    yymsp[-3].minor.yy0.type = QT_PARAM_GEO_COORD;

  if (yymsp[-1].minor.yy0.type == QT_PARAM_TERM)
    yymsp[-1].minor.yy0.type = QT_PARAM_GEO_UNIT;

  yymsp[-5].minor.yy30 = NewGeoFilterQueryParam_WithParams(ctx, &yymsp[-4].minor.yy0, &yymsp[-3].minor.yy0, &yymsp[-2].minor.yy0, &yymsp[-1].minor.yy0);
}
        break;
      case 62: /* query ::= expr ARROW LSQB vector_query RSQB */
      case 63: /* query ::= text_expr ARROW LSQB vector_query RSQB */ yytestcase(yyruleno==63);
{ // main parse, hybrid query as entire query case.
  setup_trace(ctx);
  RS_LOG_ASSERT(yymsp[-1].minor.yy51->vn.vq->type == VECSIM_QT_KNN, "vector_query must be KNN");
  ctx->root = yymsp[-1].minor.yy51;
  if (yymsp[-4].minor.yy51) {
    QueryNode_AddChild(yymsp[-1].minor.yy51, yymsp[-4].minor.yy51);
  }
}
        break;
      case 64: /* query ::= star ARROW LSQB vector_query RSQB */
{  yy_destructor(yypParser,56,&yymsp[-4].minor);
{ // main parse, simple vecsim search as entire query case.
  setup_trace(ctx);
  RS_LOG_ASSERT(yymsp[-1].minor.yy51->vn.vq->type == VECSIM_QT_KNN, "vector_query must be KNN");
  yymsp[-1].minor.yy51->vn.vq->knn.order = BY_SCORE;

  ctx->root = yymsp[-1].minor.yy51;
}
}
        break;
      case 65: /* vector_query ::= vector_command vector_attribute_list vector_score_field */
{
  if (yymsp[-2].minor.yy51->vn.vq->scoreField) {
    rm_free(yymsp[-2].minor.yy51->vn.vq->scoreField);
    yymsp[-2].minor.yy51->vn.vq->scoreField = NULL;
  }
  yymsp[-2].minor.yy51->params = array_grow(yymsp[-2].minor.yy51->params, 1);
  memset(&array_tail(yymsp[-2].minor.yy51->params), 0, sizeof(*yymsp[-2].minor.yy51->params));
  QueryNode_SetParam(ctx, &(array_tail(yymsp[-2].minor.yy51->params)), &(yymsp[-2].minor.yy51->vn.vq->scoreField), NULL, &yymsp[0].minor.yy0);
  yymsp[-2].minor.yy51->vn.vq->params = yymsp[-1].minor.yy10;
  yylhsminor.yy51 = yymsp[-2].minor.yy51;
}
  yymsp[-2].minor.yy51 = yylhsminor.yy51;
        break;
      case 66: /* vector_query ::= vector_command vector_score_field */
{
  if (yymsp[-1].minor.yy51->vn.vq->scoreField) {
    rm_free(yymsp[-1].minor.yy51->vn.vq->scoreField);
    yymsp[-1].minor.yy51->vn.vq->scoreField = NULL;
  }
  yymsp[-1].minor.yy51->params = array_grow(yymsp[-1].minor.yy51->params, 1);
  memset(&array_tail(yymsp[-1].minor.yy51->params), 0, sizeof(*yymsp[-1].minor.yy51->params));
  QueryNode_SetParam(ctx, &(array_tail(yymsp[-1].minor.yy51->params)), &(yymsp[-1].minor.yy51->vn.vq->scoreField), NULL, &yymsp[0].minor.yy0);
  yylhsminor.yy51 = yymsp[-1].minor.yy51;
}
  yymsp[-1].minor.yy51 = yylhsminor.yy51;
        break;
      case 67: /* vector_query ::= vector_command vector_attribute_list */
{
  yymsp[-1].minor.yy51->vn.vq->params = yymsp[0].minor.yy10;
  yylhsminor.yy51 = yymsp[-1].minor.yy51;
}
  yymsp[-1].minor.yy51 = yylhsminor.yy51;
        break;
      case 69: /* vector_score_field ::= as param_term */
{  yy_destructor(yypParser,62,&yymsp[-1].minor);
{
  yymsp[-1].minor.yy0 = yymsp[0].minor.yy0;
}
}
        break;
      case 70: /* query ::= expr ARROW LSQB vector_query RSQB ARROW LB attribute_list RB */
{
  setup_trace(ctx);
  RS_LOG_ASSERT(yymsp[-5].minor.yy51->vn.vq->type == VECSIM_QT_KNN, "vector_query must be KNN");
  ctx->root = yymsp[-5].minor.yy51;
  if (yymsp[-5].minor.yy51 && yymsp[-1].minor.yy33) {
     QueryNode_ApplyAttributes(yymsp[-5].minor.yy51, yymsp[-1].minor.yy33, array_len(yymsp[-1].minor.yy33), ctx->status);
  }
  array_free_ex(yymsp[-1].minor.yy33, rm_free((char*)((QueryAttribute*)ptr )->value));

  if (yymsp[-8].minor.yy51) {
      QueryNode_AddChild(yymsp[-5].minor.yy51, yymsp[-8].minor.yy51);
  }
}
        break;
      case 71: /* query ::= text_expr ARROW LSQB vector_query RSQB ARROW LB attribute_list RB */
{
  setup_trace(ctx);
  RS_LOG_ASSERT(yymsp[-5].minor.yy51->vn.vq->type == VECSIM_QT_KNN, "vector_query must be KNN");
  ctx->root = yymsp[-5].minor.yy51;
  if (yymsp[-5].minor.yy51 && yymsp[-1].minor.yy33) {
     QueryNode_ApplyAttributes(yymsp[-5].minor.yy51, yymsp[-1].minor.yy33, array_len(yymsp[-1].minor.yy33), ctx->status);
  }
  array_free_ex(yymsp[-1].minor.yy33, rm_free((char*)((QueryAttribute*)ptr )->value));

  if (yymsp[-8].minor.yy51) {
    QueryNode_AddChild(yymsp[-5].minor.yy51, yymsp[-8].minor.yy51);
  }
}
        break;
      case 72: /* query ::= star ARROW LSQB vector_query RSQB ARROW LB attribute_list RB */
{  yy_destructor(yypParser,56,&yymsp[-8].minor);
{
  setup_trace(ctx);
  RS_LOG_ASSERT(yymsp[-5].minor.yy51->vn.vq->type == VECSIM_QT_KNN, "vector_query must be KNN");
  yymsp[-5].minor.yy51->vn.vq->knn.order = BY_SCORE;

  ctx->root = yymsp[-5].minor.yy51;
  if (yymsp[-5].minor.yy51 && yymsp[-1].minor.yy33) {
     QueryNode_ApplyAttributes(yymsp[-5].minor.yy51, yymsp[-1].minor.yy33, array_len(yymsp[-1].minor.yy33), ctx->status);
  }
  array_free_ex(yymsp[-1].minor.yy33, rm_free((char*)((QueryAttribute*)ptr )->value));

}
}
        break;
      case 73: /* vector_command ::= TERM param_size modifier ATTRIBUTE */
{
  if (!strncasecmp("KNN", yymsp[-3].minor.yy0.s, yymsp[-3].minor.yy0.len)) {
    yymsp[0].minor.yy0.type = QT_PARAM_VEC;
    yylhsminor.yy51 = NewVectorNode_WithParams(ctx, VECSIM_QT_KNN, &yymsp[-2].minor.yy0, &yymsp[0].minor.yy0);
    yylhsminor.yy51->vn.vq->property = rm_strndup(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
    RedisModule_Assert(-1 != (rm_asprintf(&yylhsminor.yy51->vn.vq->scoreField, "__%.*s_score", yymsp[-1].minor.yy0.len, yymsp[-1].minor.yy0.s)));
  } else {
    reportSyntaxError(ctx->status, &yymsp[-3].minor.yy0, "Syntax error: Expecting Vector Similarity command");
    yylhsminor.yy51 = NULL;
  }
}
  yymsp[-3].minor.yy51 = yylhsminor.yy51;
        break;
      case 74: /* vector_attribute ::= TERM param_term */
{
  const char *value = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
  const char *name = rm_strndup(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
  yylhsminor.yy29.param = (VecSimRawParam){ .name = name, .nameLen = yymsp[-1].minor.yy0.len, .value = value, .valLen = yymsp[0].minor.yy0.len };
  if (yymsp[0].minor.yy0.type == QT_PARAM_TERM) {
    yylhsminor.yy29.needResolve = true;
  }
  else { // if yymsp[0].minor.yy0.type == QT_TERM
    yylhsminor.yy29.needResolve = false;
  }
}
  yymsp[-1].minor.yy29 = yylhsminor.yy29;
        break;
      case 75: /* vector_attribute_list ::= vector_attribute_list vector_attribute */
{
  yylhsminor.yy10.params = array_append(yymsp[-1].minor.yy10.params, yymsp[0].minor.yy29.param);
  yylhsminor.yy10.needResolve = array_append(yymsp[-1].minor.yy10.needResolve, yymsp[0].minor.yy29.needResolve);
}
  yymsp[-1].minor.yy10 = yylhsminor.yy10;
        break;
      case 76: /* vector_attribute_list ::= vector_attribute */
{
  yylhsminor.yy10.params = array_new(VecSimRawParam, 1);
  yylhsminor.yy10.needResolve = array_new(bool, 1);
  yylhsminor.yy10.params = array_append(yylhsminor.yy10.params, yymsp[0].minor.yy29.param);
  yylhsminor.yy10.needResolve = array_append(yylhsminor.yy10.needResolve, yymsp[0].minor.yy29.needResolve);
}
  yymsp[0].minor.yy10 = yylhsminor.yy10;
        break;
      case 77: /* expr ::= modifier COLON LSQB vector_range_command RSQB */
{
    yymsp[-1].minor.yy51->vn.vq->property = rm_strndup(yymsp[-4].minor.yy0.s, yymsp[-4].minor.yy0.len);
    yylhsminor.yy51 = yymsp[-1].minor.yy51;
}
  yymsp[-4].minor.yy51 = yylhsminor.yy51;
        break;
      case 78: /* vector_range_command ::= TERM param_num ATTRIBUTE */
{
  if (!strncasecmp("VECTOR_RANGE", yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len)) {
    yymsp[0].minor.yy0.type = QT_PARAM_VEC;
    yylhsminor.yy51 = NewVectorNode_WithParams(ctx, VECSIM_QT_RANGE, &yymsp[-1].minor.yy0, &yymsp[0].minor.yy0);
  } else {
    reportSyntaxError(ctx->status, &yymsp[-2].minor.yy0, "Syntax error: expecting vector similarity range command");
    yylhsminor.yy51 = NULL;
  }
}
  yymsp[-2].minor.yy51 = yylhsminor.yy51;
        break;
      case 79: /* num ::= SIZE */
      case 80: /* num ::= NUMBER */ yytestcase(yyruleno==80);
{
  yylhsminor.yy127.num = yymsp[0].minor.yy0.numval;
  yylhsminor.yy127.inclusive = 1;
}
  yymsp[0].minor.yy127 = yylhsminor.yy127;
        break;
      case 81: /* num ::= LP num */
{
  yymsp[-1].minor.yy127=yymsp[0].minor.yy127;
  yymsp[-1].minor.yy127.inclusive = 0;
}
        break;
      case 82: /* num ::= MINUS num */
{
  yymsp[0].minor.yy127.num = -yymsp[0].minor.yy127.num;
  yymsp[-1].minor.yy127 = yymsp[0].minor.yy127;
}
        break;
      case 83: /* term ::= TERM */
      case 84: /* term ::= NUMBER */ yytestcase(yyruleno==84);
      case 85: /* term ::= SIZE */ yytestcase(yyruleno==85);
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 86: /* param_term ::= term */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_TERM;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 87: /* param_term ::= ATTRIBUTE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_PARAM_TERM;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 88: /* param_size ::= SIZE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_SIZE;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 89: /* param_size ::= ATTRIBUTE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_PARAM_SIZE;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 90: /* param_num ::= ATTRIBUTE */
{
    yylhsminor.yy0 = yymsp[0].minor.yy0;
    yylhsminor.yy0.type = QT_PARAM_NUMERIC;
    yylhsminor.yy0.inclusive = 1;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 91: /* param_num ::= num */
{
  yylhsminor.yy0.numval = yymsp[0].minor.yy127.num;
  yylhsminor.yy0.inclusive = yymsp[0].minor.yy127.inclusive;
  yylhsminor.yy0.type = QT_NUMERIC;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 92: /* param_num ::= LP ATTRIBUTE */
{
    yymsp[-1].minor.yy0 = yymsp[0].minor.yy0;
    yymsp[-1].minor.yy0.type = QT_PARAM_NUMERIC;
    yymsp[-1].minor.yy0.inclusive = 0;
}
        break;
      case 94: /* star ::= LP star RP */
{
}
  yy_destructor(yypParser,56,&yymsp[-1].minor);
        break;
      default:
      /* (93) star ::= STAR */ yytestcase(yyruleno==93);
      /* (95) as ::= AS_T */ yytestcase(yyruleno==95);
        break;
/********** End reduce actions ************************************************/
  };
  assert( yyruleno<sizeof(yyRuleInfoLhs)/sizeof(yyRuleInfoLhs[0]) );
  yygoto = yyRuleInfoLhs[yyruleno];
  yysize = yyRuleInfoNRhs[yyruleno];
  yyact = yy_find_reduce_action(yymsp[yysize].stateno,(YYCODETYPE)yygoto);

  /* There are no SHIFTREDUCE actions on nonterminals because the table
  ** generator has simplified them to pure REDUCE actions. */
  assert( !(yyact>YY_MAX_SHIFT && yyact<=YY_MAX_SHIFTREDUCE) );

  /* It is not possible for a REDUCE to be followed by an error */
  assert( yyact!=YY_ERROR_ACTION );

  yymsp += yysize+1;
  yypParser->yytos = yymsp;
  yymsp->stateno = (YYACTIONTYPE)yyact;
  yymsp->major = (YYCODETYPE)yygoto;
  yyTraceShift(yypParser, yyact, "... then shift");
  return yyact;
}

/*
** The following code executes when the parse fails
*/
#ifndef YYNOERRORRECOVERY
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yytos>yypParser->yystack ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
/************ Begin %parse_failure code ***************************************/
/************ End %parse_failure code *****************************************/
  RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_v2_CTX_STORE
}
#endif /* YYNOERRORRECOVERY */

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  RSQueryParser_v2_TOKENTYPE yyminor         /* The minor type of the error token */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
#define TOKEN yyminor
/************ Begin %syntax_error code ****************************************/

  QueryError_SetErrorFmt(ctx->status, QUERY_ESYNTAX,
    "Syntax error at offset %d near %.*s",
    TOKEN.pos, TOKEN.len, TOKEN.s);
/************ End %syntax_error code ******************************************/
  RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_v2_CTX_STORE
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
#ifndef YYNOERRORRECOVERY
  yypParser->yyerrcnt = -1;
#endif
  assert( yypParser->yytos==yypParser->yystack );
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
/*********** Begin %parse_accept code *****************************************/
/*********** End %parse_accept code *******************************************/
  RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_v2_CTX_STORE
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "RSQueryParser_v2_Alloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void RSQueryParser_v2_(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  RSQueryParser_v2_TOKENTYPE yyminor       /* The value for the token */
  RSQueryParser_v2_ARG_PDECL               /* Optional %extra_argument parameter */
){
  YYMINORTYPE yyminorunion;
  YYACTIONTYPE yyact;   /* The parser action. */
#if !defined(YYERRORSYMBOL) && !defined(YYNOERRORRECOVERY)
  int yyendofinput;     /* True if we are at the end of input */
#endif
#ifdef YYERRORSYMBOL
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
#endif
  yyParser *yypParser = (yyParser*)yyp;  /* The parser */
  RSQueryParser_v2_CTX_FETCH
  RSQueryParser_v2_ARG_STORE

  assert( yypParser->yytos!=0 );
#if !defined(YYERRORSYMBOL) && !defined(YYNOERRORRECOVERY)
  yyendofinput = (yymajor==0);
#endif

  yyact = yypParser->yytos->stateno;
#ifndef NDEBUG
  if( yyTraceFILE ){
    if( yyact < YY_MIN_REDUCE ){
      fprintf(yyTraceFILE,"%sInput '%s' in state %d\n",
              yyTracePrompt,yyTokenName[yymajor],yyact);
    }else{
      fprintf(yyTraceFILE,"%sInput '%s' with pending reduce %d\n",
              yyTracePrompt,yyTokenName[yymajor],yyact-YY_MIN_REDUCE);
    }
  }
#endif

  while(1){ /* Exit by "break" */
    assert( yypParser->yytos>=yypParser->yystack );
    assert( yyact==yypParser->yytos->stateno );
    yyact = yy_find_shift_action((YYCODETYPE)yymajor,yyact);
    if( yyact >= YY_MIN_REDUCE ){
      unsigned int yyruleno = yyact - YY_MIN_REDUCE; /* Reduce by this rule */
#ifndef NDEBUG
      assert( yyruleno<(int)(sizeof(yyRuleName)/sizeof(yyRuleName[0])) );
      if( yyTraceFILE ){
        int yysize = yyRuleInfoNRhs[yyruleno];
        if( yysize ){
          fprintf(yyTraceFILE, "%sReduce %d [%s]%s, pop back to state %d.\n",
            yyTracePrompt,
            yyruleno, yyRuleName[yyruleno],
            yyruleno<YYNRULE_WITH_ACTION ? "" : " without external action",
            yypParser->yytos[yysize].stateno);
        }else{
          fprintf(yyTraceFILE, "%sReduce %d [%s]%s.\n",
            yyTracePrompt, yyruleno, yyRuleName[yyruleno],
            yyruleno<YYNRULE_WITH_ACTION ? "" : " without external action");
        }
      }
#endif /* NDEBUG */

      /* Check that the stack is large enough to grow by a single entry
      ** if the RHS of the rule is empty.  This ensures that there is room
      ** enough on the stack to push the LHS value */
      if( yyRuleInfoNRhs[yyruleno]==0 ){
#ifdef YYTRACKMAXSTACKDEPTH
        if( (int)(yypParser->yytos - yypParser->yystack)>yypParser->yyhwm ){
          yypParser->yyhwm++;
          assert( yypParser->yyhwm ==
                  (int)(yypParser->yytos - yypParser->yystack));
        }
#endif
#if YYSTACKDEPTH>0 
        if( yypParser->yytos>=yypParser->yystackEnd ){
          yyStackOverflow(yypParser);
          break;
        }
#else
        if( yypParser->yytos>=&yypParser->yystack[yypParser->yystksz-1] ){
          if( yyGrowStack(yypParser) ){
            yyStackOverflow(yypParser);
            break;
          }
        }
#endif
      }
      yyact = yy_reduce(yypParser,yyruleno,yymajor,yyminor RSQueryParser_v2_CTX_PARAM);
    }else if( yyact <= YY_MAX_SHIFTREDUCE ){
      yy_shift(yypParser,yyact,(YYCODETYPE)yymajor,yyminor);
#ifndef YYNOERRORRECOVERY
      yypParser->yyerrcnt--;
#endif
      break;
    }else if( yyact==YY_ACCEPT_ACTION ){
      yypParser->yytos--;
      yy_accept(yypParser);
      return;
    }else{
      assert( yyact == YY_ERROR_ACTION );
      yyminorunion.yy0 = yyminor;
#ifdef YYERRORSYMBOL
      int yymx;
#endif
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->yyerrcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminor);
      }
      yymx = yypParser->yytos->major;
      if( yymx==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yypParser, (YYCODETYPE)yymajor, &yyminorunion);
        yymajor = YYNOCODE;
      }else{
        while( yypParser->yytos > yypParser->yystack ){
          yyact = yy_find_reduce_action(yypParser->yytos->stateno,
                                        YYERRORSYMBOL);
          if( yyact<=YY_MAX_SHIFTREDUCE ) break;
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->yytos <= yypParser->yystack || yymajor==0 ){
          yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
          yy_parse_failed(yypParser);
#ifndef YYNOERRORRECOVERY
          yypParser->yyerrcnt = -1;
#endif
          yymajor = YYNOCODE;
        }else if( yymx!=YYERRORSYMBOL ){
          yy_shift(yypParser,yyact,YYERRORSYMBOL,yyminor);
        }
      }
      yypParser->yyerrcnt = 3;
      yyerrorhit = 1;
      if( yymajor==YYNOCODE ) break;
      yyact = yypParser->yytos->stateno;
#elif defined(YYNOERRORRECOVERY)
      /* If the YYNOERRORRECOVERY macro is defined, then do not attempt to
      ** do any kind of error recovery.  Instead, simply invoke the syntax
      ** error routine and continue going as if nothing had happened.
      **
      ** Applications can set this macro (for example inside %include) if
      ** they intend to abandon the parse upon the first syntax error seen.
      */
      yy_syntax_error(yypParser,yymajor, yyminor);
      yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
      break;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->yyerrcnt<=0 ){
        yy_syntax_error(yypParser,yymajor, yyminor);
      }
      yypParser->yyerrcnt = 3;
      yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser);
#ifndef YYNOERRORRECOVERY
        yypParser->yyerrcnt = -1;
#endif
      }
      break;
#endif
    }
  }
#ifndef NDEBUG
  if( yyTraceFILE ){
    yyStackEntry *i;
    char cDiv = '[';
    fprintf(yyTraceFILE,"%sReturn. Stack=",yyTracePrompt);
    for(i=&yypParser->yystack[1]; i<=yypParser->yytos; i++){
      fprintf(yyTraceFILE,"%c%s", cDiv, yyTokenName[i->major]);
      cDiv = ' ';
    }
    fprintf(yyTraceFILE,"]\n");
  }
#endif
  return;
}

/*
** Return the fallback token corresponding to canonical token iToken, or
** 0 if iToken has no fallback.
*/
int RSQueryParser_v2_Fallback(int iToken){
#ifdef YYFALLBACK
  assert( iToken<(int)(sizeof(yyFallback)/sizeof(yyFallback[0])) );
  return yyFallback[iToken];
#else
  (void)iToken;
  return 0;
#endif
}
